!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 24

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(231)
  integer, parameter :: nGC_13 = 1
  integer, parameter :: nGC_10 = 2
  integer, parameter :: nGC_MC = 3
  integer, parameter :: nGC_MB = 4
  integer, parameter :: nGC_478 = 5
  integer, parameter :: nGC_4124 = 6
  integer, parameter :: nGC_28 = 7
  integer, parameter :: nGC_15 = 8
  integer, parameter :: nGC_24 = 9
  integer, parameter :: nGC_MD = 10
  integer, parameter :: nGC_16 = 11
  integer, parameter :: nGC_MI = 12
  integer, parameter :: nGC_14 = 13
  integer, parameter :: nGC_12 = 14
  integer, parameter :: nGC_11 = 15
  integer, parameter :: nGC_2459 = 16
  integer, parameter :: nGC_2458 = 17
  integer, parameter :: nGC_MS = 18
  integer, parameter :: nGC_MU = 19
  integer, parameter :: nGC_2571 = 20
  integer, parameter :: nGC_2572 = 21
  integer, parameter :: nGC_4100 = 22
  integer, parameter :: nGC_3662 = 23
  integer, parameter :: nGC_3660 = 24
  integer, parameter :: nGC_2474 = 25
  integer, parameter :: nGC_2471 = 26
  integer, parameter :: nGC_2470 = 27
  integer, parameter :: nGC_2473 = 28
  integer, parameter :: nGC_2472 = 29
  integer, parameter :: nGC_2569 = 30
  integer, parameter :: nGC_2566 = 31
  integer, parameter :: nGC_2567 = 32
  integer, parameter :: nGC_2561 = 33
  integer, parameter :: nGC_88 = 34
  integer, parameter :: nGC_2462 = 35
  integer, parameter :: nGC_2463 = 36
  integer, parameter :: nGC_2460 = 37
  integer, parameter :: nGC_2461 = 38
  integer, parameter :: nGC_2466 = 39
  integer, parameter :: nGC_2467 = 40
  integer, parameter :: nGC_2464 = 41
  integer, parameter :: nGC_2465 = 42
  integer, parameter :: nGC_2468 = 43
  integer, parameter :: nGC_2469 = 44
  integer, parameter :: nGC_2557 = 45
  integer, parameter :: nGC_2570 = 46
  integer, parameter :: nGC_2573 = 47
  integer, parameter :: nGC_3 = 48
  integer, parameter :: nGC_2 = 49
  integer, parameter :: nGC_1 = 50
  integer, parameter :: nGC_7 = 51
  integer, parameter :: nGC_6 = 52
  integer, parameter :: nGC_5 = 53
  integer, parameter :: nGC_4 = 54
  integer, parameter :: nGC_9 = 55
  integer, parameter :: nGC_8 = 56
  integer, parameter :: nGC_3788 = 57
  integer, parameter :: nGC_3785 = 58
  integer, parameter :: nGC_3786 = 59
  integer, parameter :: nGC_4046 = 60
  integer, parameter :: nGC_4047 = 61
  integer, parameter :: nGC_2491 = 62
  integer, parameter :: nGC_3659 = 63
  integer, parameter :: nGC_52 = 64
  integer, parameter :: nGC_3908 = 65
  integer, parameter :: nGC_3909 = 66
  integer, parameter :: nGC_4123 = 67
  integer, parameter :: nGC_3907 = 68
  integer, parameter :: nGC_4127 = 69
  integer, parameter :: nGC_4126 = 70
  integer, parameter :: nGC_3863 = 71
  integer, parameter :: nGC_3864 = 72
  integer, parameter :: nGC_1488 = 73
  integer, parameter :: nGC_2554 = 74
  integer, parameter :: nGC_2553 = 75
  integer, parameter :: nGC_2486 = 76
  integer, parameter :: nGC_2487 = 77
  integer, parameter :: nGC_2480 = 78
  integer, parameter :: nGC_2558 = 79
  integer, parameter :: nGC_2559 = 80
  integer, parameter :: nGC_3874 = 81
  integer, parameter :: nGC_3871 = 82
  integer, parameter :: nGC_46 = 83
  integer, parameter :: nGC_2490 = 84
  integer, parameter :: nGC_2489 = 85
  integer, parameter :: nGC_368 = 86
  integer, parameter :: nGC_4417 = 87
  integer, parameter :: nGC_2527 = 88
  integer, parameter :: nGC_382 = 89
  integer, parameter :: nGC_836 = 90
  integer, parameter :: nGC_2528 = 91
  integer, parameter :: nGC_830 = 92
  integer, parameter :: nGC_4418 = 93
  integer, parameter :: nGC_3726 = 94
  integer, parameter :: nGC_3725 = 95
  integer, parameter :: nGC_376 = 96
  integer, parameter :: nGC_2500 = 97
  integer, parameter :: nGC_2478 = 98
  integer, parameter :: nGC_2530 = 99
  integer, parameter :: nGC_132 = 100
  integer, parameter :: nGC_378 = 101
  integer, parameter :: nGC_1468 = 102
  integer, parameter :: nGC_3680 = 103
  integer, parameter :: nGC_1466 = 104
  integer, parameter :: nGC_4097 = 105
  integer, parameter :: nGC_4098 = 106
  integer, parameter :: nGC_2508 = 107
  integer, parameter :: nGC_2505 = 108
  integer, parameter :: nGC_2504 = 109
  integer, parameter :: nGC_2507 = 110
  integer, parameter :: nGC_2506 = 111
  integer, parameter :: nGC_2501 = 112
  integer, parameter :: nGC_2503 = 113
  integer, parameter :: nGC_2502 = 114
  integer, parameter :: nGC_3827 = 115
  integer, parameter :: nGC_1474 = 116
  integer, parameter :: nGC_1476 = 117
  integer, parameter :: nGC_2529 = 118
  integer, parameter :: nGC_2519 = 119
  integer, parameter :: nGC_1440 = 120
  integer, parameter :: nGC_2513 = 121
  integer, parameter :: nGC_2510 = 122
  integer, parameter :: nGC_2511 = 123
  integer, parameter :: nGC_2516 = 124
  integer, parameter :: nGC_2517 = 125
  integer, parameter :: nGC_2515 = 126
  integer, parameter :: nGC_3666 = 127
  integer, parameter :: nGC_3830 = 128
  integer, parameter :: nGC_3663 = 129
  integer, parameter :: nGC_5941 = 130
  integer, parameter :: nGC_2483 = 131
  integer, parameter :: nGC_98 = 132
  integer, parameter :: nGC_2475 = 133
  integer, parameter :: nGC_2477 = 134
  integer, parameter :: nGC_2476 = 135
  integer, parameter :: nGC_3766 = 136
  integer, parameter :: nGC_3767 = 137
  integer, parameter :: nGC_3768 = 138
  integer, parameter :: nGC_2479 = 139
  integer, parameter :: nGC_4332 = 140
  integer, parameter :: nGC_2488 = 141
  integer, parameter :: nGC_2565 = 142
  integer, parameter :: nGC_2564 = 143
  integer, parameter :: nGC_2563 = 144
  integer, parameter :: nGC_2562 = 145
  integer, parameter :: nGC_4101 = 146
  integer, parameter :: nGC_3673 = 147
  integer, parameter :: nGC_4664 = 148
  integer, parameter :: nGC_4665 = 149
  integer, parameter :: nGC_2485 = 150
  integer, parameter :: nGC_2560 = 151
  integer, parameter :: nGC_86 = 152
  integer, parameter :: nGC_4669 = 153
  integer, parameter :: nGC_616 = 154
  integer, parameter :: nGC_2492 = 155
  integer, parameter :: nGC_4053 = 156
  integer, parameter :: nGC_3717 = 157
  integer, parameter :: nGC_3716 = 158
  integer, parameter :: nGC_2482 = 159
  integer, parameter :: nGC_3640 = 160
  integer, parameter :: nGC_1486 = 161
  integer, parameter :: nGC_3910 = 162
  integer, parameter :: nGC_3718 = 163
  integer, parameter :: nGC_2523 = 164
  integer, parameter :: nGC_2522 = 165
  integer, parameter :: nGC_4048 = 166
  integer, parameter :: nGC_3655 = 167
  integer, parameter :: nGC_2534 = 168
  integer, parameter :: nGC_3789 = 169
  integer, parameter :: nGC_3650 = 170
  integer, parameter :: nGC_2498 = 171
  integer, parameter :: nGC_2497 = 172
  integer, parameter :: nGC_2496 = 173
  integer, parameter :: nGC_2495 = 174
  integer, parameter :: nGC_2494 = 175
  integer, parameter :: nGC_2493 = 176
  integer, parameter :: nGC_2518 = 177
  integer, parameter :: nGC_3641 = 178
  integer, parameter :: nGC_2549 = 179
  integer, parameter :: nGC_2548 = 180
  integer, parameter :: nGC_2520 = 181
  integer, parameter :: nGC_2509 = 182
  integer, parameter :: nGC_3729 = 183
  integer, parameter :: nGC_2541 = 184
  integer, parameter :: nGC_2540 = 185
  integer, parameter :: nGC_2543 = 186
  integer, parameter :: nGC_2542 = 187
  integer, parameter :: nGC_2545 = 188
  integer, parameter :: nGC_2544 = 189
  integer, parameter :: nGC_3720 = 190
  integer, parameter :: nGC_2526 = 191
  integer, parameter :: nGC_2512 = 192
  integer, parameter :: nGC_2499 = 193
  integer, parameter :: nGC_2524 = 194
  integer, parameter :: nGC_3865 = 195
  integer, parameter :: nGC_2525 = 196
  integer, parameter :: nGC_3866 = 197
  integer, parameter :: nGC_2538 = 198
  integer, parameter :: nGC_2547 = 199
  integer, parameter :: nGC_2521 = 200
  integer, parameter :: nGC_4159 = 201
  integer, parameter :: nGC_3698 = 202
  integer, parameter :: nGC_2546 = 203
  integer, parameter :: nGC_3777 = 204
  integer, parameter :: nGC_4668 = 205
  integer, parameter :: nGC_2536 = 206
  integer, parameter :: nGC_2531 = 207
  integer, parameter :: nGC_2532 = 208
  integer, parameter :: nGC_4333 = 209
  integer, parameter :: nGC_2552 = 210
  integer, parameter :: nGC_2535 = 211
  integer, parameter :: nGC_2550 = 212
  integer, parameter :: nGC_2551 = 213
  integer, parameter :: nGC_2484 = 214
  integer, parameter :: nGC_2539 = 215
  integer, parameter :: nGC_2481 = 216
  integer, parameter :: nGC_2514 = 217
  integer, parameter :: nGC_3876 = 218
  integer, parameter :: nGC_3730 = 219
  integer, parameter :: nGC_3875 = 220
  integer, parameter :: nGC_3832 = 221
  integer, parameter :: nGC_3831 = 222
  integer, parameter :: nGC_2537 = 223
  integer, parameter :: nGC_3685 = 224
  integer, parameter :: nGC_2533 = 225
  integer, parameter :: nGC_4142 = 226
  integer, parameter :: nGC_3761 = 227
  integer, parameter :: nGC_3798 = 228
  integer, parameter :: nGC_3719 = 229
  integer, parameter :: nGC_3699 = 230
  integer, parameter :: nGC_5943 = 231
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
