!******************************************************************************!
!                                                                              !
!    fill_couplings1.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_couplings1.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_couplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_couplings_mdl1()
    coupl(nGC_13) = 4d0*cggh*cima/vev
    coupl(nGC_10) = -4d0*cggh*cima/vev**2d0
    coupl(nGC_MC) = -cMC*cima
    coupl(nGC_MB) = -cMB*cima
    coupl(nGC_478) = -coupl(nGC_13)
    coupl(nGC_28) = 4d0*cima/vev
    coupl(nGC_15) = -4d0*cggh*cima*gs**2d0/vev
    coupl(nGC_24) = cima*gs
    coupl(nGC_MD) = -cMD*cima
    coupl(nGC_16) = -3d0*cima*lam*vev/2d0
    coupl(nGC_MI) = -cima
    coupl(nGC_14) = 4d0*cggh*gs/vev
    coupl(nGC_12) = 4d0*cggh*cima*gs**2d0/vev**2d0
    coupl(nGC_11) = -4d0*cggh*gs/vev**2d0
    coupl(nGC_2459) = -gs
    coupl(nGC_2458) = 8d0*cima/vev**3d0
    coupl(nGC_MS) = -cMS*cima
    coupl(nGC_MU) = -cMU*cima
    coupl(nGC_2474) = 4d0*cima*gs**2d0/vev**2d0
    coupl(nGC_2471) = -8d0*cggh*cima*gs**2d0/vev
    coupl(nGC_2470) = -8d0*cima*gs**2d0/vev**3d0
    coupl(nGC_2473) = 8d0*cggh*cima*gs**2d0/vev**2d0
    coupl(nGC_2472) = -4d0*cima*gs**2d0/vev
    coupl(nGC_88) = 2d0*coupl(nGC_12)
    coupl(nGC_2462) = 2d0*cima*gs**2d0
    coupl(nGC_2463) = -4d0*cima/vev**2d0
    coupl(nGC_2460) = -4d0*cggh*gs/vev**2d0
    coupl(nGC_2461) = -4d0*gs/vev**2d0
    coupl(nGC_2466) = 4d0*gs/vev
    coupl(nGC_2467) = 8d0*cggh*gs/vev**3d0
    coupl(nGC_2464) = -2d0*gs
    coupl(nGC_2465) = 4d0*cggh*gs/vev
    coupl(nGC_2468) = 8d0*gs/vev**3d0
    coupl(nGC_2469) = -16d0*cggh*cima*gs**2d0/vev**3d0
    coupl(nGC_3) = cima*gs
    coupl(nGC_2) = -gs
    coupl(nGC_1) = -2d0*gs
    coupl(nGC_7) = 8d0*cggh*cima/vev**3d0
    coupl(nGC_6) = -3d0*cima*lam/2d0
    coupl(nGC_5) = cima*gs**2d0
    coupl(nGC_4) = -cima*gs**2d0
    coupl(nGC_9) = -8d0*cggh*cima*gs**2d0/vev**3d0
    coupl(nGC_8) = 8d0*cggh*gs/vev**3d0
    coupl(nGC_52) = -coupl(nGC_10)
    coupl(nGC_1488) = -coupl(nGC_4) - coupl(nGC_5)
    coupl(nGC_46) = -coupl(nGC_11)
    coupl(nGC_368) = 2d0*coupl(nGC_5)
    coupl(nGC_382) = -2d0*coupl(nGC_15)
    coupl(nGC_836) = -coupl(nGC_2)
    coupl(nGC_830) = -coupl(nGC_14)
    coupl(nGC_376) = -coupl(nGC_15)
    coupl(nGC_132) = -coupl(nGC_7)
    coupl(nGC_378) = 2d0*coupl(nGC_15)
    coupl(nGC_1468) = -2d0*coupl(nGC_5)
    coupl(nGC_1466) = -coupl(nGC_5)
    coupl(nGC_1474) = coupl(nGC_4) - coupl(nGC_5)
    coupl(nGC_1476) = -coupl(nGC_4) + coupl(nGC_5)
    coupl(nGC_1440) = -coupl(nGC_8)
    coupl(nGC_98) = -2d0*coupl(nGC_12)
    coupl(nGC_86) = -coupl(nGC_12)
    coupl(nGC_616) = -coupl(nGC_9)
    coupl(nGC_1486) = coupl(nGC_4) + coupl(nGC_5)
  end subroutine fill_couplings_mdl1
end module fill_couplings1
