!******************************************************************************!
!                                                                              !
!    fill_ctcouplings1.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings1.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings1
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl1()
    coupl(nGC_4124) = coupl(nGC_MB)*(dZbL_QCD2 + dZbR_QCD2)/2d0
    coupl(nGC_2571) = -cima*dMC_QCD2
    coupl(nGC_2572) = -cima*dMS_QCD2
    coupl(nGC_4100) = coupl(nGC_MI)*dZuR_QCD2
    coupl(nGC_3662) = coupl(nGC_MI)*dZdR_QCD2
    coupl(nGC_3660) = coupl(nGC_MD)*(dZdL_QCD2 + dZdR_QCD2)/2d0
    coupl(nGC_2569) = -cima*dMU_QCD2
    coupl(nGC_2566) = coupl(nGC_2473)*dZgs_QCD2 + coupl(nGC_2474)*dcggh_QCD4
    coupl(nGC_2567) = coupl(nGC_2471)*dZgs_QCD2 + coupl(nGC_2472)*dcggh_QCD4
    coupl(nGC_2561) = coupl(nGC_28)*dcggh_QCD4
    coupl(nGC_2557) = coupl(nGC_24)*dZgs_QCD2
    coupl(nGC_2570) = -cima*dMD_QCD2
    coupl(nGC_2573) = -cima*dMB_QCD2
    coupl(nGC_3788) = coupl(nGC_MI)*dZsR_QCD2
    coupl(nGC_3785) = coupl(nGC_MI)*dZsL_QCD2
    coupl(nGC_3786) = coupl(nGC_MS)*(dZsL_QCD2 + dZsR_QCD2)/2d0
    coupl(nGC_4046) = 2d0*coupl(nGC_15)*dZg_QCD2 + coupl(nGC_2567)
    coupl(nGC_4047) = -coupl(nGC_4046)
    coupl(nGC_2491) = cMS*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_13) +  &
                      8d0*Nc**2d0*coupl(nGC_478) - coupl(nGC_13) - 8d0*coupl(  &
                      nGC_478))/(128d0*pi**2d0*Nc)
    coupl(nGC_3659) = coupl(nGC_MI)*dZdL_QCD2
    coupl(nGC_3908) = coupl(nGC_MC)*(dZcL_QCD2 + dZcR_QCD2)/2d0
    coupl(nGC_3909) = coupl(nGC_MI)*dZcR_QCD2
    coupl(nGC_4123) = coupl(nGC_MI)*dZbL_QCD2
    coupl(nGC_3907) = coupl(nGC_MI)*dZcL_QCD2
    coupl(nGC_4127) = coupl(nGC_2573) + coupl(nGC_4124)
    coupl(nGC_4126) = coupl(nGC_MI)*dZbR_QCD2
    coupl(nGC_3863) = coupl(nGC_3)*dZsR_QCD2
    coupl(nGC_3864) = coupl(nGC_3)*dZsL_QCD2
    coupl(nGC_2554) = coupl(nGC_2462)*dZgs_QCD2
    coupl(nGC_2553) = coupl(nGC_2459)*dZgs_QCD2
    coupl(nGC_2486) = cima*coupl(nGC_3)**2d0*sq2**2d0*(-cMB**2d0 - cMC**2d0 -  &
                      cMD**2d0 - cMS**2d0 - cMU**2d0)/(16d0*pi**2d0*Nc)
    coupl(nGC_2487) = coupl(nGC_3)**2d0*sq2**2d0*(-2d0*Nc**2d0*coupl(nGC_13) - &
                      5d0*Nc**2d0*coupl(nGC_478) + 2d0*coupl(nGC_13) + 5d0*    &
                      coupl(nGC_478))/(384d0*pi**2d0*Nc)
    coupl(nGC_2480) = cMS*cima*coupl(nGC_3)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_2558) = coupl(nGC_2464)*dZgs_QCD2
    coupl(nGC_2559) = coupl(nGC_2458)*dcggh_QCD4
    coupl(nGC_3874) = coupl(nGC_3)*dZuR_QCD2
    coupl(nGC_3871) = coupl(nGC_3)*dZuL_QCD2
    coupl(nGC_2490) = cMD*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_13) +  &
                      8d0*Nc**2d0*coupl(nGC_478) - coupl(nGC_13) - 8d0*coupl(  &
                      nGC_478))/(128d0*pi**2d0*Nc)
    coupl(nGC_2489) = cMB*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_13) +  &
                      8d0*Nc**2d0*coupl(nGC_478) - coupl(nGC_13) - 8d0*coupl(  &
                      nGC_478))/(128d0*pi**2d0*Nc)
    coupl(nGC_4417) = coupl(nGC_MI)*dZg_QCD2
    coupl(nGC_2527) = -5d0*cima*coupl(nGC_3)**4d0*sq2**4d0/(64d0*pi**2d0*Nc**  &
                      3d0)
    coupl(nGC_2528) = 5d0*cima*coupl(nGC_3)**4d0*sq2**4d0/(192d0*pi**2d0*Nc**  &
                      2d0)
    coupl(nGC_4418) = -coupl(nGC_4417)
    coupl(nGC_3726) = coupl(nGC_3)*dZcR_QCD2
    coupl(nGC_3725) = coupl(nGC_3)*dZcL_QCD2
    coupl(nGC_2500) = sq2**3d0*(-Nc*cima*coupl(nGC_836)**3d0 + 10d0*coupl(nGC_3&
                      )**3d0)/(192d0*pi**2d0)
    coupl(nGC_2478) = cMD*cima*coupl(nGC_3)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_2530) = coupl(nGC_3)**2d0*sq2**3d0*(12d0*Nc**2d0*cima*coupl(     &
                      nGC_46) + 2d0*Nc**2d0*coupl(nGC_10)*coupl(nGC_836) - 16d0&
                      *Nc**2d0*coupl(nGC_52)*coupl(nGC_836) - 5d0*cima*coupl(  &
                      nGC_10)*coupl(nGC_3) - 14d0*cima*coupl(nGC_3)*coupl(     &
                      nGC_52))/(768d0*pi**2d0*Nc)
    coupl(nGC_3680) = 3d0*coupl(nGC_2)*dZg_QCD2/2d0 + coupl(nGC_2553)
  end subroutine fill_CTcouplings_mdl1
end module fill_ctcouplings1
