!******************************************************************************!
!                                                                              !
!    fill_ctcouplings2.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings2.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings2
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl2()
    coupl(nGC_4097) = coupl(nGC_MI)*dZuL_QCD2
    coupl(nGC_4098) = coupl(nGC_MU)*(dZuL_QCD2 + dZuR_QCD2)/2d0
    coupl(nGC_2508) = cMB*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_10) +  &
                      8d0*Nc**2d0*coupl(nGC_52) - coupl(nGC_10) - 8d0*coupl(   &
                      nGC_52))/(128d0*pi**2d0*Nc)
    coupl(nGC_2505) = coupl(nGC_3)**2d0*sq2**3d0*(-12d0*Nc**2d0*cima*coupl(    &
                      nGC_830) - 2d0*Nc**2d0*coupl(nGC_13)*coupl(nGC_836) +    &
                      16d0*Nc**2d0*coupl(nGC_478)*coupl(nGC_836) + 5d0*cima*   &
                      coupl(nGC_13)*coupl(nGC_3) + 14d0*cima*coupl(nGC_3)*coupl&
                      (nGC_478))/(768d0*pi**2d0*Nc**2d0)
    coupl(nGC_2504) = cMS*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_10) +  &
                      8d0*Nc**2d0*coupl(nGC_52) - coupl(nGC_10) - 8d0*coupl(   &
                      nGC_52))/(128d0*pi**2d0*Nc)
    coupl(nGC_2507) = cMC*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_10) +  &
                      8d0*Nc**2d0*coupl(nGC_52) - coupl(nGC_10) - 8d0*coupl(   &
                      nGC_52))/(128d0*pi**2d0*Nc)
    coupl(nGC_2506) = coupl(nGC_3)**2d0*sq2**3d0*(12d0*Nc**2d0*cima*coupl(     &
                      nGC_830) + 2d0*Nc**2d0*coupl(nGC_13)*coupl(nGC_836) -    &
                      16d0*Nc**2d0*coupl(nGC_478)*coupl(nGC_836) - 5d0*cima*   &
                      coupl(nGC_13)*coupl(nGC_3) - 14d0*cima*coupl(nGC_3)*coupl&
                      (nGC_478))/(768d0*pi**2d0*Nc)
    coupl(nGC_2501) = cMU*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_10) +  &
                      8d0*Nc**2d0*coupl(nGC_52) - coupl(nGC_10) - 8d0*coupl(   &
                      nGC_52))/(128d0*pi**2d0*Nc)
    coupl(nGC_2503) = cMD*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_10) +  &
                      8d0*Nc**2d0*coupl(nGC_52) - coupl(nGC_10) - 8d0*coupl(   &
                      nGC_52))/(128d0*pi**2d0*Nc)
    coupl(nGC_2502) = coupl(nGC_3)**2d0*sq2**2d0*(2d0*Nc**2d0*coupl(nGC_10) +  &
                      5d0*Nc**2d0*coupl(nGC_52) - 2d0*coupl(nGC_10) - 5d0*coupl&
                      (nGC_52))/(192d0*pi**2d0*Nc)
    coupl(nGC_3827) = coupl(nGC_3)*dZdL_QCD2
    coupl(nGC_2529) = coupl(nGC_3)**2d0*sq2**3d0*(-12d0*Nc**2d0*cima*coupl(    &
                      nGC_46) - 2d0*Nc**2d0*coupl(nGC_10)*coupl(nGC_836) + 16d0&
                      *Nc**2d0*coupl(nGC_52)*coupl(nGC_836) + 5d0*cima*coupl(  &
                      nGC_10)*coupl(nGC_3) + 14d0*cima*coupl(nGC_3)*coupl(     &
                      nGC_52))/(768d0*pi**2d0*Nc**2d0)
    coupl(nGC_2519) = cima*sq2**4d0*(-2d0*Nc*coupl(nGC_836)**4d0 - 25d0*coupl( &
                      nGC_3)**4d0)/(384d0*pi**2d0)
    coupl(nGC_2513) = coupl(nGC_836)**2d0*sq2**2d0*(coupl(nGC_10) - 20d0*coupl(&
                      nGC_52))/(192d0*pi**2d0)
    coupl(nGC_2510) = Nc*coupl(nGC_836)**2d0*sq2**2d0*(-coupl(nGC_10) + 20d0*  &
                      coupl(nGC_52))/(192d0*pi**2d0)
    coupl(nGC_2511) = Nc*(2d0*cima*coupl(nGC_10)*coupl(nGC_1466) + 2d0*cima*   &
                      coupl(nGC_10)*coupl(nGC_4) + 20d0*cima*coupl(nGC_1466)*  &
                      coupl(nGC_52) + 2d0*cima*coupl(nGC_1468)*coupl(nGC_52) + &
                      2d0*cima*coupl(nGC_1474)*coupl(nGC_52) + 2d0*cima*coupl( &
                      nGC_1476)*coupl(nGC_52) + 2d0*cima*coupl(nGC_368)*coupl( &
                      nGC_52) + 20d0*cima*coupl(nGC_4)*coupl(nGC_52) - coupl(  &
                      nGC_10)*coupl(nGC_836)**2d0*sq2**2d0 - 40d0*coupl(nGC_52 &
                      )*coupl(nGC_836)**2d0*sq2**2d0)/(192d0*pi**2d0)
    coupl(nGC_2516) = Nc*coupl(nGC_836)*sq2*(-2d0*cima*coupl(nGC_13)*coupl(    &
                      nGC_1466) + 2d0*cima*coupl(nGC_13)*coupl(nGC_4) - 14d0*  &
                      cima*coupl(nGC_1466)*coupl(nGC_478) + 4d0*cima*coupl(    &
                      nGC_1468)*coupl(nGC_478) + 8d0*cima*coupl(nGC_1474)*coupl&
                      (nGC_478) - 4d0*cima*coupl(nGC_1476)*coupl(nGC_478) - 8d0&
                      *cima*coupl(nGC_368)*coupl(nGC_478) + 14d0*cima*coupl(   &
                      nGC_4)*coupl(nGC_478) + 6d0*cima*coupl(nGC_830)*coupl(   &
                      nGC_836)*sq2**2d0 - coupl(nGC_13)*coupl(nGC_836)**2d0*sq2&
                      **2d0 - 10d0*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 &
                      )/(384d0*pi**2d0)
    coupl(nGC_2517) = Nc*coupl(nGC_836)*sq2*(2d0*cima*coupl(nGC_13)*coupl(     &
                      nGC_1466) - 2d0*cima*coupl(nGC_13)*coupl(nGC_4) + 14d0*  &
                      cima*coupl(nGC_1466)*coupl(nGC_478) - 4d0*cima*coupl(    &
                      nGC_1468)*coupl(nGC_478) - 8d0*cima*coupl(nGC_1474)*coupl&
                      (nGC_478) + 4d0*cima*coupl(nGC_1476)*coupl(nGC_478) + 8d0&
                      *cima*coupl(nGC_368)*coupl(nGC_478) - 14d0*cima*coupl(   &
                      nGC_4)*coupl(nGC_478) - 6d0*cima*coupl(nGC_830)*coupl(   &
                      nGC_836)*sq2**2d0 + coupl(nGC_13)*coupl(nGC_836)**2d0*sq2&
                      **2d0 + 10d0*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 &
                      )/(384d0*pi**2d0)
    coupl(nGC_2515) = Nc*coupl(nGC_836)*sq2*(2d0*cima*coupl(nGC_13)*coupl(     &
                      nGC_1466) - 2d0*cima*coupl(nGC_13)*coupl(nGC_4) + 14d0*  &
                      cima*coupl(nGC_1466)*coupl(nGC_478) + 8d0*cima*coupl(    &
                      nGC_1468)*coupl(nGC_478) + 4d0*cima*coupl(nGC_1474)*coupl&
                      (nGC_478) - 8d0*cima*coupl(nGC_1476)*coupl(nGC_478) - 4d0&
                      *cima*coupl(nGC_368)*coupl(nGC_478) - 14d0*cima*coupl(   &
                      nGC_4)*coupl(nGC_478) + 6d0*cima*coupl(nGC_830)*coupl(   &
                      nGC_836)*sq2**2d0 - coupl(nGC_13)*coupl(nGC_836)**2d0*sq2&
                      **2d0 - 10d0*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 &
                      )/(384d0*pi**2d0)
    coupl(nGC_3666) = coupl(nGC_2554) + coupl(nGC_5)*dZg_QCD2
    coupl(nGC_3830) = coupl(nGC_3)*dZdR_QCD2
    coupl(nGC_3663) = coupl(nGC_2570) + coupl(nGC_3660)
    coupl(nGC_5941) = -coupl(nGC_2500)
    coupl(nGC_2483) = cima*coupl(nGC_3)**2d0*sq2**2d0*(cMB**2d0 + cMC**2d0 +   &
                      cMD**2d0 + cMS**2d0 + cMU**2d0)/(16d0*pi**2d0)
    coupl(nGC_2475) = cima*coupl(nGC_3)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(64d0*pi&
                      **2d0*Nc)
    coupl(nGC_2477) = cMU*cima*coupl(nGC_3)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_2476) = cMB*cima*coupl(nGC_3)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_3766) = 2d0*coupl(nGC_12)*dZg_QCD2 + coupl(nGC_2566)
    coupl(nGC_3767) = -coupl(nGC_3766)
    coupl(nGC_3768) = 2d0*coupl(nGC_3766)
    coupl(nGC_2479) = cMC*cima*coupl(nGC_3)**2d0*sq2**2d0*(-Nc**2d0 + 1d0)/(   &
                      32d0*pi**2d0*Nc)
    coupl(nGC_4332) = coupl(nGC_13)*dZg_QCD2 + coupl(nGC_2561)
    coupl(nGC_2488) = cMC*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_13) +  &
                      8d0*Nc**2d0*coupl(nGC_478) - coupl(nGC_13) - 8d0*coupl(  &
                      nGC_478))/(128d0*pi**2d0*Nc)
    coupl(nGC_2565) = coupl(nGC_2469)*dZgs_QCD2 + coupl(nGC_2470)*dcggh_QCD4
    coupl(nGC_2564) = coupl(nGC_2465)*dZgs_QCD2 + coupl(nGC_2466)*dcggh_QCD4
    coupl(nGC_2563) = coupl(nGC_2460)*dZgs_QCD2 + coupl(nGC_2461)*dcggh_QCD4
    coupl(nGC_2562) = coupl(nGC_2467)*dZgs_QCD2 + coupl(nGC_2468)*dcggh_QCD4
    coupl(nGC_4101) = coupl(nGC_2569) + coupl(nGC_4098)
    coupl(nGC_3673) = 2d0*coupl(nGC_3666)
    coupl(nGC_4664) = coupl(nGC_2554) + 2d0*coupl(nGC_5)*dZg_QCD2
    coupl(nGC_4665) = -2d0*coupl(nGC_4664)
    coupl(nGC_2485) = cima*coupl(nGC_836)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_2560) = coupl(nGC_2463)*dcggh_QCD4
    coupl(nGC_4669) = 2d0*coupl(nGC_4664)
    coupl(nGC_2492) = cMU*coupl(nGC_3)**2d0*sq2**2d0*(Nc**2d0*coupl(nGC_13) +  &
                      8d0*Nc**2d0*coupl(nGC_478) - coupl(nGC_13) - 8d0*coupl(  &
                      nGC_478))/(128d0*pi**2d0*Nc)
    coupl(nGC_4053) = -2d0*coupl(nGC_4046)
    coupl(nGC_3717) = coupl(nGC_3)*dZbL_QCD2
    coupl(nGC_3716) = coupl(nGC_3)*dZbR_QCD2
    coupl(nGC_2482) = -Nc*cima*coupl(nGC_836)**2d0*sq2**2d0/(96d0*pi**2d0)
    coupl(nGC_3640) = coupl(nGC_2559) + coupl(nGC_7)*dZg_QCD2
  end subroutine fill_CTcouplings_mdl2
end module fill_ctcouplings2
