!******************************************************************************!
!                                                                              !
!    fill_ctcouplings3.f90                                                     !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   fill_ctcouplings3.f90                          |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module fill_ctcouplings3
  use constants_mdl
  use class_couplings
  use class_ctparameters
  implicit none
  contains
  subroutine fill_CTcouplings_mdl3()
    coupl(nGC_3910) = coupl(nGC_2571) + coupl(nGC_3908)
    coupl(nGC_3718) = coupl(nGC_2557) + coupl(nGC_3)*dZg_QCD2/2d0
    coupl(nGC_2523) = (cima*coupl(nGC_1474)**2d0 - cima*coupl(nGC_836)**4d0*sq2&
                      **4d0 - 2d0*coupl(nGC_1474)*coupl(nGC_836)**2d0*sq2**2d0 &
                      )/(32d0*pi**2d0)
    coupl(nGC_2522) = (cima*coupl(nGC_1466)**2d0 + 2d0*cima*coupl(nGC_1466)*   &
                      coupl(nGC_4) + cima*coupl(nGC_4)**2d0 - cima*coupl(      &
                      nGC_836)**4d0*sq2**4d0 - 2d0*coupl(nGC_1466)*coupl(      &
                      nGC_836)**2d0*sq2**2d0 - 2d0*coupl(nGC_4)*coupl(nGC_836  &
                      )**2d0*sq2**2d0)/(32d0*pi**2d0)
    coupl(nGC_4048) = 2d0*coupl(nGC_4046)
    coupl(nGC_3655) = coupl(nGC_1)*dZg_QCD2/2d0 + coupl(nGC_2558)
    coupl(nGC_2534) = Nc*coupl(nGC_836)*sq2*(-2d0*cima*coupl(nGC_10)*coupl(    &
                      nGC_1466) + 2d0*cima*coupl(nGC_10)*coupl(nGC_4) - 14d0*  &
                      cima*coupl(nGC_1466)*coupl(nGC_52) - 8d0*cima*coupl(     &
                      nGC_1468)*coupl(nGC_52) - 4d0*cima*coupl(nGC_1474)*coupl(&
                      nGC_52) + 8d0*cima*coupl(nGC_1476)*coupl(nGC_52) + 4d0*  &
                      cima*coupl(nGC_368)*coupl(nGC_52) + 14d0*cima*coupl(nGC_4&
                      )*coupl(nGC_52) - 6d0*cima*coupl(nGC_46)*coupl(nGC_836)* &
                      sq2**2d0 + coupl(nGC_10)*coupl(nGC_836)**2d0*sq2**2d0 +  &
                      10d0*coupl(nGC_52)*coupl(nGC_836)**2d0*sq2**2d0)/(384d0* &
                      pi**2d0)
    coupl(nGC_3789) = coupl(nGC_2572) + coupl(nGC_3786)
    coupl(nGC_3650) = coupl(nGC_2562) + 3d0*coupl(nGC_8)*dZg_QCD2/2d0
    coupl(nGC_2498) = coupl(nGC_3)**2d0*sq2**3d0*(Nc**2d0*cima*coupl(nGC_836   &
                      ) - 2d0*coupl(nGC_3))/(128d0*pi**2d0*Nc)
    coupl(nGC_2497) = coupl(nGC_3)**2d0*sq2**3d0*(-Nc**2d0*cima*coupl(nGC_836  &
                      ) + 2d0*coupl(nGC_3))/(128d0*pi**2d0*Nc**2d0)
    coupl(nGC_2496) = Nc*coupl(nGC_836)*sq2**2d0*(4d0*cima*coupl(nGC_830) -    &
                      coupl(nGC_13)*coupl(nGC_836) + 16d0*coupl(nGC_478)*coupl(&
                      nGC_836))/(192d0*pi**2d0)
    coupl(nGC_2495) = Nc*(cima*coupl(nGC_13)*coupl(nGC_1466) + cima*coupl(     &
                      nGC_13)*coupl(nGC_4) + 10d0*cima*coupl(nGC_1466)*coupl(  &
                      nGC_478) + cima*coupl(nGC_1468)*coupl(nGC_478) + cima*   &
                      coupl(nGC_1474)*coupl(nGC_478) + cima*coupl(nGC_1476)*   &
                      coupl(nGC_478) + cima*coupl(nGC_368)*coupl(nGC_478) +    &
                      10d0*cima*coupl(nGC_4)*coupl(nGC_478) + 2d0*cima*coupl(  &
                      nGC_830)*coupl(nGC_836)*sq2**2d0 - coupl(nGC_13)*coupl(  &
                      nGC_836)**2d0*sq2**2d0 - 12d0*coupl(nGC_478)*coupl(      &
                      nGC_836)**2d0*sq2**2d0)/(192d0*pi**2d0)
    coupl(nGC_2494) = coupl(nGC_836)*sq2**2d0*(-4d0*cima*coupl(nGC_830) + coupl&
                      (nGC_13)*coupl(nGC_836) - 16d0*coupl(nGC_478)*coupl(     &
                      nGC_836))/(192d0*pi**2d0)
    coupl(nGC_2493) = (-cima*coupl(nGC_13)*coupl(nGC_1474) - 10d0*cima*coupl(  &
                      nGC_1474)*coupl(nGC_478) - cima*coupl(nGC_1486)*coupl(   &
                      nGC_478) - cima*coupl(nGC_1488)*coupl(nGC_478) - 2d0*cima&
                      *coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 + coupl(nGC_13)* &
                      coupl(nGC_836)**2d0*sq2**2d0 + 12d0*coupl(nGC_478)*coupl(&
                      nGC_836)**2d0*sq2**2d0)/(192d0*pi**2d0)
    coupl(nGC_2518) = Nc*coupl(nGC_836)*sq2*(-2d0*cima*coupl(nGC_13)*coupl(    &
                      nGC_1466) + 2d0*cima*coupl(nGC_13)*coupl(nGC_4) - 14d0*  &
                      cima*coupl(nGC_1466)*coupl(nGC_478) - 8d0*cima*coupl(    &
                      nGC_1468)*coupl(nGC_478) - 4d0*cima*coupl(nGC_1474)*coupl&
                      (nGC_478) + 8d0*cima*coupl(nGC_1476)*coupl(nGC_478) + 4d0&
                      *cima*coupl(nGC_368)*coupl(nGC_478) + 14d0*cima*coupl(   &
                      nGC_4)*coupl(nGC_478) - 6d0*cima*coupl(nGC_830)*coupl(   &
                      nGC_836)*sq2**2d0 + coupl(nGC_13)*coupl(nGC_836)**2d0*sq2&
                      **2d0 + 10d0*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 &
                      )/(384d0*pi**2d0)
    coupl(nGC_3641) = -coupl(nGC_3640)
    coupl(nGC_2549) = Nc*(-8d0*cima*coupl(nGC_830)*coupl(nGC_836)**3d0*sq2**4d0&
                       + coupl(nGC_13)*coupl(nGC_836)**4d0*sq2**4d0 - 6d0*coupl&
                      (nGC_1468)*coupl(nGC_1476)*coupl(nGC_478) - 6d0*coupl(   &
                      nGC_1468)*coupl(nGC_368)*coupl(nGC_478) - 6d0*coupl(     &
                      nGC_1474)*coupl(nGC_1476)*coupl(nGC_478) - 6d0*coupl(    &
                      nGC_1474)*coupl(nGC_368)*coupl(nGC_478) + 12d0*coupl(    &
                      nGC_478)*coupl(nGC_836)**4d0*sq2**4d0)/(384d0*pi**2d0)
    coupl(nGC_2548) = Nc*(-2d0*cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836&
                      )**2d0*sq2**2d0 - 4d0*cima*coupl(nGC_13)*coupl(nGC_4)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + 12d0*cima*coupl(nGC_1466)*&
                      coupl(nGC_376) - 20d0*cima*coupl(nGC_1466)*coupl(nGC_478 &
                      )*coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1468 &
                      )*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 4d0*cima*&
                      coupl(nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2** &
                      2d0 - 4d0*cima*coupl(nGC_1476)*coupl(nGC_478)*coupl(     &
                      nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_368)*coupl(  &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 + 12d0*cima*coupl( &
                      nGC_376)*coupl(nGC_4) - 40d0*cima*coupl(nGC_4)*coupl(    &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*coupl(  &
                      nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 - 3d0*coupl(nGC_13 &
                      )*coupl(nGC_1466)**2d0 - 3d0*coupl(nGC_13)*coupl(nGC_4)**&
                      2d0 + coupl(nGC_13)*coupl(nGC_836)**4d0*sq2**4d0 - 24d0* &
                      coupl(nGC_1466)**2d0*coupl(nGC_478) - 6d0*coupl(nGC_1466 &
                      )*coupl(nGC_1468)*coupl(nGC_478) - 6d0*coupl(nGC_1466)*  &
                      coupl(nGC_368)*coupl(nGC_478) - 12d0*coupl(nGC_1466)*    &
                      coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 - 6d0*coupl(      &
                      nGC_1468)*coupl(nGC_1474)*coupl(nGC_478) - 6d0*coupl(    &
                      nGC_1474)*coupl(nGC_4)*coupl(nGC_478) - 6d0*coupl(       &
                      nGC_1476)*coupl(nGC_368)*coupl(nGC_478) - 6d0*coupl(     &
                      nGC_1476)*coupl(nGC_4)*coupl(nGC_478) - 12d0*coupl(      &
                      nGC_376)*coupl(nGC_836)**2d0*sq2**2d0 - 24d0*coupl(nGC_4 &
                      )**2d0*coupl(nGC_478) - 12d0*coupl(nGC_4)*coupl(nGC_830)*&
                      coupl(nGC_836)*sq2**2d0 + 12d0*coupl(nGC_478)*coupl(     &
                      nGC_836)**4d0*sq2**4d0)/(384d0*pi**2d0)
    coupl(nGC_2520) = (6d0*Nc*cima*coupl(nGC_1466)**2d0 + 6d0*Nc*cima*coupl(   &
                      nGC_4)**2d0 - 2d0*Nc*cima*coupl(nGC_836)**4d0*sq2**4d0 - &
                      6d0*Nc*coupl(nGC_1466)*coupl(nGC_836)**2d0*sq2**2d0 - 6d0&
                      *Nc*coupl(nGC_4)*coupl(nGC_836)**2d0*sq2**2d0 + 15d0*cima&
                      *coupl(nGC_3)**4d0*sq2**4d0)/(384d0*pi**2d0)
    coupl(nGC_2509) = Nc*(cima*coupl(nGC_10)*coupl(nGC_1466) + cima*coupl(     &
                      nGC_10)*coupl(nGC_4) + 10d0*cima*coupl(nGC_1466)*coupl(  &
                      nGC_52) + cima*coupl(nGC_1468)*coupl(nGC_52) + cima*coupl&
                      (nGC_1474)*coupl(nGC_52) + cima*coupl(nGC_1476)*coupl(   &
                      nGC_52) + cima*coupl(nGC_368)*coupl(nGC_52) + 10d0*cima* &
                      coupl(nGC_4)*coupl(nGC_52) + 2d0*cima*coupl(nGC_46)*coupl&
                      (nGC_836)*sq2**2d0 - coupl(nGC_10)*coupl(nGC_836)**2d0*  &
                      sq2**2d0 - 12d0*coupl(nGC_52)*coupl(nGC_836)**2d0*sq2**  &
                      2d0)/(192d0*pi**2d0)
    coupl(nGC_3729) = coupl(nGC_3718) + coupl(nGC_3726)
    coupl(nGC_2541) = (-2d0*cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836)**&
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_13)*coupl(nGC_4)*coupl(&
                      nGC_836)**2d0*sq2**2d0 + 8d0*cima*coupl(nGC_1466)*coupl( &
                      nGC_376) - 20d0*cima*coupl(nGC_1466)*coupl(nGC_478)*coupl&
                      (nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1468)*coupl(&
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(  &
                      nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 -  &
                      2d0*cima*coupl(nGC_1476)*coupl(nGC_478)*coupl(nGC_836)** &
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_368)*coupl(nGC_478)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + 8d0*cima*coupl(nGC_376)*  &
                      coupl(nGC_4) - 20d0*cima*coupl(nGC_4)*coupl(nGC_478)*    &
                      coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*coupl(nGC_830)*  &
                      coupl(nGC_836)**3d0*sq2**4d0 - coupl(nGC_13)*coupl(      &
                      nGC_1466)**2d0 - 2d0*coupl(nGC_13)*coupl(nGC_1466)*coupl(&
                      nGC_4) - coupl(nGC_13)*coupl(nGC_4)**2d0 + coupl(nGC_13)*&
                      coupl(nGC_836)**4d0*sq2**4d0 - 8d0*coupl(nGC_1466)**2d0* &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1468)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1474)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1476)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_368)*coupl&
                      (nGC_478) - 16d0*coupl(nGC_1466)*coupl(nGC_4)*coupl(     &
                      nGC_478) - 8d0*coupl(nGC_1466)*coupl(nGC_830)*coupl(     &
                      nGC_836)*sq2**2d0 - 2d0*coupl(nGC_1468)*coupl(nGC_4)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_4)*coupl( &
                      nGC_478) - 2d0*coupl(nGC_1476)*coupl(nGC_4)*coupl(nGC_478&
                      ) - 4d0*coupl(nGC_1486)*coupl(nGC_1488)*coupl(nGC_478) - &
                      2d0*coupl(nGC_368)*coupl(nGC_4)*coupl(nGC_478) - 8d0*    &
                      coupl(nGC_376)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*coupl( &
                      nGC_4)**2d0*coupl(nGC_478) - 8d0*coupl(nGC_4)*coupl(     &
                      nGC_830)*coupl(nGC_836)*sq2**2d0 + 12d0*coupl(nGC_478)*  &
                      coupl(nGC_836)**4d0*sq2**4d0)/(64d0*pi**2d0)
    coupl(nGC_2540) = (cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836)**2d0* &
                      sq2**2d0 + cima*coupl(nGC_13)*coupl(nGC_1474)*coupl(     &
                      nGC_836)**2d0*sq2**2d0 + cima*coupl(nGC_13)*coupl(nGC_4)*&
                      coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1466)* &
                      coupl(nGC_382) + 10d0*cima*coupl(nGC_1466)*coupl(nGC_478 &
                      )*coupl(nGC_836)**2d0*sq2**2d0 + cima*coupl(nGC_1468)*   &
                      coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 4d0*cima*  &
                      coupl(nGC_1474)*coupl(nGC_376) + 11d0*cima*coupl(nGC_1474&
                      )*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 + cima*    &
                      coupl(nGC_1476)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2** &
                      2d0 + cima*coupl(nGC_1486)*coupl(nGC_478)*coupl(nGC_836  &
                      )**2d0*sq2**2d0 + cima*coupl(nGC_1488)*coupl(nGC_478)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + cima*coupl(nGC_368)*coupl(&
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(  &
                      nGC_382)*coupl(nGC_4) + 10d0*cima*coupl(nGC_4)*coupl(    &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 + 8d0*cima*coupl(  &
                      nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 + coupl(nGC_13)*   &
                      coupl(nGC_1466)*coupl(nGC_1474) + coupl(nGC_13)*coupl(   &
                      nGC_1474)*coupl(nGC_4) - coupl(nGC_13)*coupl(nGC_836)**  &
                      4d0*sq2**4d0 + 8d0*coupl(nGC_1466)*coupl(nGC_1474)*coupl(&
                      nGC_478) + coupl(nGC_1466)*coupl(nGC_1486)*coupl(nGC_478 &
                      ) + coupl(nGC_1466)*coupl(nGC_1488)*coupl(nGC_478) + 4d0*&
                      coupl(nGC_1466)*coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 + &
                      coupl(nGC_1468)*coupl(nGC_1474)*coupl(nGC_478) + 2d0*    &
                      coupl(nGC_1468)*coupl(nGC_1488)*coupl(nGC_478) + coupl(  &
                      nGC_1474)**2d0*coupl(nGC_478) + coupl(nGC_1474)*coupl(   &
                      nGC_1476)*coupl(nGC_478) + 2d0*coupl(nGC_1474)*coupl(    &
                      nGC_1486)*coupl(nGC_478) + coupl(nGC_1474)*coupl(nGC_368 &
                      )*coupl(nGC_478) + 8d0*coupl(nGC_1474)*coupl(nGC_4)*coupl&
                      (nGC_478) + 4d0*coupl(nGC_1474)*coupl(nGC_830)*coupl(    &
                      nGC_836)*sq2**2d0 + 2d0*coupl(nGC_1476)*coupl(nGC_1488)* &
                      coupl(nGC_478) + 2d0*coupl(nGC_1486)*coupl(nGC_368)*coupl&
                      (nGC_478) + coupl(nGC_1486)*coupl(nGC_4)*coupl(nGC_478   &
                      ) + coupl(nGC_1488)*coupl(nGC_4)*coupl(nGC_478) + 4d0*   &
                      coupl(nGC_376)*coupl(nGC_836)**2d0*sq2**2d0 + 2d0*coupl( &
                      nGC_382)*coupl(nGC_836)**2d0*sq2**2d0 + 4d0*coupl(nGC_4)*&
                      coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 - 12d0*coupl(     &
                      nGC_478)*coupl(nGC_836)**4d0*sq2**4d0)/(128d0*pi**2d0)
    coupl(nGC_2543) = (-2d0*cima*coupl(nGC_13)*coupl(nGC_1474)*coupl(nGC_836)**&
                      2d0*sq2**2d0 + 4d0*cima*coupl(nGC_1474)*coupl(nGC_382) - &
                      20d0*cima*coupl(nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**&
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1486)*coupl(nGC_478)*  &
                      coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1488)* &
                      coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*  &
                      coupl(nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 - coupl(     &
                      nGC_13)*coupl(nGC_1474)**2d0 + coupl(nGC_13)*coupl(      &
                      nGC_836)**4d0*sq2**4d0 - coupl(nGC_1468)**2d0*coupl(     &
                      nGC_478) - 2d0*coupl(nGC_1468)*coupl(nGC_1476)*coupl(    &
                      nGC_478) - 9d0*coupl(nGC_1474)**2d0*coupl(nGC_478) - 2d0*&
                      coupl(nGC_1474)*coupl(nGC_1486)*coupl(nGC_478) - 2d0*    &
                      coupl(nGC_1474)*coupl(nGC_1488)*coupl(nGC_478) - 2d0*    &
                      coupl(nGC_1474)*coupl(nGC_368)*coupl(nGC_478) - 8d0*coupl&
                      (nGC_1474)*coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 - coupl&
                      (nGC_1476)**2d0*coupl(nGC_478) - coupl(nGC_1486)**2d0*   &
                      coupl(nGC_478) - coupl(nGC_1488)**2d0*coupl(nGC_478) -   &
                      coupl(nGC_368)**2d0*coupl(nGC_478) - 4d0*coupl(nGC_382)* &
                      coupl(nGC_836)**2d0*sq2**2d0 + 12d0*coupl(nGC_478)*coupl(&
                      nGC_836)**4d0*sq2**4d0)/(64d0*pi**2d0)
    coupl(nGC_2542) = (-2d0*cima*coupl(nGC_13)*coupl(nGC_1474)*coupl(nGC_836)**&
                      2d0*sq2**2d0 + 4d0*cima*coupl(nGC_1474)*coupl(nGC_382) - &
                      20d0*cima*coupl(nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**&
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1486)*coupl(nGC_478)*  &
                      coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1488)* &
                      coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*  &
                      coupl(nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 - coupl(     &
                      nGC_13)*coupl(nGC_1474)**2d0 + coupl(nGC_13)*coupl(      &
                      nGC_836)**4d0*sq2**4d0 - 2d0*coupl(nGC_1468)*coupl(      &
                      nGC_1474)*coupl(nGC_478) - 2d0*coupl(nGC_1468)*coupl(    &
                      nGC_368)*coupl(nGC_478) - 8d0*coupl(nGC_1474)**2d0*coupl(&
                      nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_1476)*coupl(    &
                      nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_1486)*coupl(    &
                      nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_1488)*coupl(    &
                      nGC_478) - 8d0*coupl(nGC_1474)*coupl(nGC_830)*coupl(     &
                      nGC_836)*sq2**2d0 - 2d0*coupl(nGC_1476)*coupl(nGC_368)*  &
                      coupl(nGC_478) - coupl(nGC_1486)**2d0*coupl(nGC_478) -   &
                      coupl(nGC_1488)**2d0*coupl(nGC_478) - 4d0*coupl(nGC_382)*&
                      coupl(nGC_836)**2d0*sq2**2d0 + 12d0*coupl(nGC_478)*coupl(&
                      nGC_836)**4d0*sq2**4d0)/(64d0*pi**2d0)
    coupl(nGC_2545) = (-2d0*cima*coupl(nGC_13)*coupl(nGC_1474)*coupl(nGC_836)**&
                      2d0*sq2**2d0 + 4d0*cima*coupl(nGC_1474)*coupl(nGC_382) - &
                      20d0*cima*coupl(nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**&
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1486)*coupl(nGC_478)*  &
                      coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1488)* &
                      coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*  &
                      coupl(nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 - coupl(     &
                      nGC_13)*coupl(nGC_1474)**2d0 + coupl(nGC_13)*coupl(      &
                      nGC_836)**4d0*sq2**4d0 - coupl(nGC_1468)**2d0*coupl(     &
                      nGC_478) - 2d0*coupl(nGC_1468)*coupl(nGC_1476)*coupl(    &
                      nGC_478) - 9d0*coupl(nGC_1474)**2d0*coupl(nGC_478) - 2d0*&
                      coupl(nGC_1474)*coupl(nGC_1486)*coupl(nGC_478) - 2d0*    &
                      coupl(nGC_1474)*coupl(nGC_1488)*coupl(nGC_478) - 2d0*    &
                      coupl(nGC_1474)*coupl(nGC_368)*coupl(nGC_478) - 8d0*coupl&
                      (nGC_1474)*coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 - coupl&
                      (nGC_1476)**2d0*coupl(nGC_478) - 2d0*coupl(nGC_1486)*    &
                      coupl(nGC_1488)*coupl(nGC_478) - coupl(nGC_368)**2d0*    &
                      coupl(nGC_478) - 4d0*coupl(nGC_382)*coupl(nGC_836)**2d0* &
                      sq2**2d0 + 12d0*coupl(nGC_478)*coupl(nGC_836)**4d0*sq2** &
                      4d0)/(64d0*pi**2d0)
    coupl(nGC_2544) = (-2d0*cima*coupl(nGC_13)*coupl(nGC_1474)*coupl(nGC_836)**&
                      2d0*sq2**2d0 + 4d0*cima*coupl(nGC_1474)*coupl(nGC_382) - &
                      20d0*cima*coupl(nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**&
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1486)*coupl(nGC_478)*  &
                      coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1488)* &
                      coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*  &
                      coupl(nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 - coupl(     &
                      nGC_13)*coupl(nGC_1474)**2d0 + coupl(nGC_13)*coupl(      &
                      nGC_836)**4d0*sq2**4d0 - 2d0*coupl(nGC_1468)*coupl(      &
                      nGC_1474)*coupl(nGC_478) - 2d0*coupl(nGC_1468)*coupl(    &
                      nGC_368)*coupl(nGC_478) - 8d0*coupl(nGC_1474)**2d0*coupl(&
                      nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_1476)*coupl(    &
                      nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_1486)*coupl(    &
                      nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_1488)*coupl(    &
                      nGC_478) - 8d0*coupl(nGC_1474)*coupl(nGC_830)*coupl(     &
                      nGC_836)*sq2**2d0 - 2d0*coupl(nGC_1476)*coupl(nGC_368)*  &
                      coupl(nGC_478) - 2d0*coupl(nGC_1486)*coupl(nGC_1488)*    &
                      coupl(nGC_478) - 4d0*coupl(nGC_382)*coupl(nGC_836)**2d0* &
                      sq2**2d0 + 12d0*coupl(nGC_478)*coupl(nGC_836)**4d0*sq2** &
                      4d0)/(64d0*pi**2d0)
    coupl(nGC_3720) = coupl(nGC_3717) + coupl(nGC_3718)
    coupl(nGC_2526) = (12d0*Nc*cima*coupl(nGC_1466)*coupl(nGC_4) - 2d0*Nc*cima*&
                      coupl(nGC_836)**4d0*sq2**4d0 - 12d0*Nc*coupl(nGC_1466)*  &
                      coupl(nGC_836)**2d0*sq2**2d0 + 15d0*cima*coupl(nGC_3)**  &
                      4d0*sq2**4d0)/(384d0*pi**2d0)
    coupl(nGC_2512) = (-cima*coupl(nGC_10)*coupl(nGC_1474) - 10d0*cima*coupl(  &
                      nGC_1474)*coupl(nGC_52) - cima*coupl(nGC_1486)*coupl(    &
                      nGC_52) - cima*coupl(nGC_1488)*coupl(nGC_52) - 2d0*cima* &
                      coupl(nGC_46)*coupl(nGC_836)*sq2**2d0 + coupl(nGC_10)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + 12d0*coupl(nGC_52)*coupl( &
                      nGC_836)**2d0*sq2**2d0)/(192d0*pi**2d0)
    coupl(nGC_2499) = sq2**3d0*(Nc*cima*coupl(nGC_836)**3d0 - 10d0*coupl(nGC_3 &
                      )**3d0)/(192d0*pi**2d0)
    coupl(nGC_2524) = (12d0*Nc*cima*coupl(nGC_1466)*coupl(nGC_4) - 2d0*Nc*cima*&
                      coupl(nGC_836)**4d0*sq2**4d0 - 6d0*Nc*coupl(nGC_1466)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 - 6d0*Nc*coupl(nGC_4)*coupl(&
                      nGC_836)**2d0*sq2**2d0 + 15d0*cima*coupl(nGC_3)**4d0*sq2 &
                      **4d0)/(384d0*pi**2d0)
    coupl(nGC_3865) = coupl(nGC_3718) + coupl(nGC_3863)
    coupl(nGC_2525) = (6d0*Nc*cima*coupl(nGC_1466)**2d0 + 6d0*Nc*cima*coupl(   &
                      nGC_4)**2d0 - 2d0*Nc*cima*coupl(nGC_836)**4d0*sq2**4d0 - &
                      12d0*Nc*coupl(nGC_4)*coupl(nGC_836)**2d0*sq2**2d0 + 15d0*&
                      cima*coupl(nGC_3)**4d0*sq2**4d0)/(384d0*pi**2d0)
    coupl(nGC_3866) = coupl(nGC_3718) + coupl(nGC_3864)
    coupl(nGC_2538) = (cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836)**2d0* &
                      sq2**2d0 + cima*coupl(nGC_13)*coupl(nGC_1474)*coupl(     &
                      nGC_836)**2d0*sq2**2d0 + cima*coupl(nGC_13)*coupl(nGC_4)*&
                      coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1466)* &
                      coupl(nGC_382) + 10d0*cima*coupl(nGC_1466)*coupl(nGC_478 &
                      )*coupl(nGC_836)**2d0*sq2**2d0 + cima*coupl(nGC_1468)*   &
                      coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 4d0*cima*  &
                      coupl(nGC_1474)*coupl(nGC_376) + 11d0*cima*coupl(nGC_1474&
                      )*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 + cima*    &
                      coupl(nGC_1476)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2** &
                      2d0 + cima*coupl(nGC_1486)*coupl(nGC_478)*coupl(nGC_836  &
                      )**2d0*sq2**2d0 + cima*coupl(nGC_1488)*coupl(nGC_478)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + cima*coupl(nGC_368)*coupl(&
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(  &
                      nGC_382)*coupl(nGC_4) + 10d0*cima*coupl(nGC_4)*coupl(    &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 + 8d0*cima*coupl(  &
                      nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 + coupl(nGC_13)*   &
                      coupl(nGC_1466)*coupl(nGC_1474) + coupl(nGC_13)*coupl(   &
                      nGC_1474)*coupl(nGC_4) - coupl(nGC_13)*coupl(nGC_836)**  &
                      4d0*sq2**4d0 + 8d0*coupl(nGC_1466)*coupl(nGC_1474)*coupl(&
                      nGC_478) + coupl(nGC_1466)*coupl(nGC_1486)*coupl(nGC_478 &
                      ) + coupl(nGC_1466)*coupl(nGC_1488)*coupl(nGC_478) + 4d0*&
                      coupl(nGC_1466)*coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 + &
                      coupl(nGC_1468)*coupl(nGC_1474)*coupl(nGC_478) + 2d0*    &
                      coupl(nGC_1468)*coupl(nGC_1486)*coupl(nGC_478) + coupl(  &
                      nGC_1474)**2d0*coupl(nGC_478) + coupl(nGC_1474)*coupl(   &
                      nGC_1476)*coupl(nGC_478) + 2d0*coupl(nGC_1474)*coupl(    &
                      nGC_1488)*coupl(nGC_478) + coupl(nGC_1474)*coupl(nGC_368 &
                      )*coupl(nGC_478) + 8d0*coupl(nGC_1474)*coupl(nGC_4)*coupl&
                      (nGC_478) + 4d0*coupl(nGC_1474)*coupl(nGC_830)*coupl(    &
                      nGC_836)*sq2**2d0 + 2d0*coupl(nGC_1476)*coupl(nGC_1486)* &
                      coupl(nGC_478) + coupl(nGC_1486)*coupl(nGC_4)*coupl(     &
                      nGC_478) + 2d0*coupl(nGC_1488)*coupl(nGC_368)*coupl(     &
                      nGC_478) + coupl(nGC_1488)*coupl(nGC_4)*coupl(nGC_478) + &
                      4d0*coupl(nGC_376)*coupl(nGC_836)**2d0*sq2**2d0 + 2d0*   &
                      coupl(nGC_382)*coupl(nGC_836)**2d0*sq2**2d0 + 4d0*coupl( &
                      nGC_4)*coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 - 12d0*    &
                      coupl(nGC_478)*coupl(nGC_836)**4d0*sq2**4d0)/(128d0*pi** &
                      2d0)
    coupl(nGC_2547) = (-2d0*cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836)**&
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_13)*coupl(nGC_4)*coupl(&
                      nGC_836)**2d0*sq2**2d0 + 8d0*cima*coupl(nGC_1466)*coupl( &
                      nGC_376) - 20d0*cima*coupl(nGC_1466)*coupl(nGC_478)*coupl&
                      (nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1468)*coupl(&
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(  &
                      nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 -  &
                      2d0*cima*coupl(nGC_1476)*coupl(nGC_478)*coupl(nGC_836)** &
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_368)*coupl(nGC_478)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + 8d0*cima*coupl(nGC_376)*  &
                      coupl(nGC_4) - 20d0*cima*coupl(nGC_4)*coupl(nGC_478)*    &
                      coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*coupl(nGC_830)*  &
                      coupl(nGC_836)**3d0*sq2**4d0 - coupl(nGC_13)*coupl(      &
                      nGC_1466)**2d0 - 2d0*coupl(nGC_13)*coupl(nGC_1466)*coupl(&
                      nGC_4) - coupl(nGC_13)*coupl(nGC_4)**2d0 + coupl(nGC_13)*&
                      coupl(nGC_836)**4d0*sq2**4d0 - 8d0*coupl(nGC_1466)**2d0* &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1468)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1474)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1476)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_368)*coupl&
                      (nGC_478) - 16d0*coupl(nGC_1466)*coupl(nGC_4)*coupl(     &
                      nGC_478) - 8d0*coupl(nGC_1466)*coupl(nGC_830)*coupl(     &
                      nGC_836)*sq2**2d0 - 2d0*coupl(nGC_1468)*coupl(nGC_4)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_4)*coupl( &
                      nGC_478) - 2d0*coupl(nGC_1476)*coupl(nGC_4)*coupl(nGC_478&
                      ) - coupl(nGC_1486)**2d0*coupl(nGC_478) - 2d0*coupl(     &
                      nGC_1486)*coupl(nGC_1488)*coupl(nGC_478) - coupl(nGC_1488&
                      )**2d0*coupl(nGC_478) - 2d0*coupl(nGC_368)*coupl(nGC_4)* &
                      coupl(nGC_478) - 8d0*coupl(nGC_376)*coupl(nGC_836)**2d0* &
                      sq2**2d0 - 8d0*coupl(nGC_4)**2d0*coupl(nGC_478) - 8d0*   &
                      coupl(nGC_4)*coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 +    &
                      12d0*coupl(nGC_478)*coupl(nGC_836)**4d0*sq2**4d0)/(64d0* &
                      pi**2d0)
    coupl(nGC_2521) = (-6d0*Nc*cima*coupl(nGC_1466)*coupl(nGC_1474) - 6d0*Nc*  &
                      cima*coupl(nGC_1474)*coupl(nGC_4) + 6d0*Nc*cima*coupl(   &
                      nGC_836)**4d0*sq2**4d0 + 6d0*Nc*coupl(nGC_1466)*coupl(   &
                      nGC_836)**2d0*sq2**2d0 + 6d0*Nc*coupl(nGC_1474)*coupl(   &
                      nGC_836)**2d0*sq2**2d0 + 6d0*Nc*coupl(nGC_4)*coupl(      &
                      nGC_836)**2d0*sq2**2d0 - 5d0*cima*coupl(nGC_3)**4d0*sq2**&
                      4d0)/(384d0*pi**2d0*Nc)
    coupl(nGC_4159) = -coupl(nGC_3650)
    coupl(nGC_3698) = coupl(nGC_10)*dZg_QCD2 + coupl(nGC_2560)
    coupl(nGC_2546) = (-2d0*cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836)**&
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_13)*coupl(nGC_4)*coupl(&
                      nGC_836)**2d0*sq2**2d0 + 8d0*cima*coupl(nGC_1466)*coupl( &
                      nGC_376) - 20d0*cima*coupl(nGC_1466)*coupl(nGC_478)*coupl&
                      (nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_1468)*coupl(&
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*coupl(  &
                      nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 -  &
                      2d0*cima*coupl(nGC_1476)*coupl(nGC_478)*coupl(nGC_836)** &
                      2d0*sq2**2d0 - 2d0*cima*coupl(nGC_368)*coupl(nGC_478)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + 8d0*cima*coupl(nGC_376)*  &
                      coupl(nGC_4) - 20d0*cima*coupl(nGC_4)*coupl(nGC_478)*    &
                      coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*coupl(nGC_830)*  &
                      coupl(nGC_836)**3d0*sq2**4d0 - coupl(nGC_13)*coupl(      &
                      nGC_1466)**2d0 - 2d0*coupl(nGC_13)*coupl(nGC_1466)*coupl(&
                      nGC_4) - coupl(nGC_13)*coupl(nGC_4)**2d0 + coupl(nGC_13)*&
                      coupl(nGC_836)**4d0*sq2**4d0 - 8d0*coupl(nGC_1466)**2d0* &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1468)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1474)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_1476)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1466)*coupl(nGC_368)*coupl&
                      (nGC_478) - 16d0*coupl(nGC_1466)*coupl(nGC_4)*coupl(     &
                      nGC_478) - 8d0*coupl(nGC_1466)*coupl(nGC_830)*coupl(     &
                      nGC_836)*sq2**2d0 - 2d0*coupl(nGC_1468)*coupl(nGC_4)*    &
                      coupl(nGC_478) - 2d0*coupl(nGC_1474)*coupl(nGC_4)*coupl( &
                      nGC_478) - 2d0*coupl(nGC_1476)*coupl(nGC_4)*coupl(nGC_478&
                      ) - 2d0*coupl(nGC_1486)**2d0*coupl(nGC_478) - 2d0*coupl( &
                      nGC_1488)**2d0*coupl(nGC_478) - 2d0*coupl(nGC_368)*coupl(&
                      nGC_4)*coupl(nGC_478) - 8d0*coupl(nGC_376)*coupl(nGC_836 &
                      )**2d0*sq2**2d0 - 8d0*coupl(nGC_4)**2d0*coupl(nGC_478) - &
                      8d0*coupl(nGC_4)*coupl(nGC_830)*coupl(nGC_836)*sq2**2d0  &
                       + 12d0*coupl(nGC_478)*coupl(nGC_836)**4d0*sq2**4d0)/(   &
                      64d0*pi**2d0)
    coupl(nGC_3777) = -2d0*coupl(nGC_3766)
    coupl(nGC_4668) = -coupl(nGC_4664)
    coupl(nGC_2536) = Nc*(-3d0*cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836&
                      )**2d0*sq2**2d0 - 3d0*cima*coupl(nGC_13)*coupl(nGC_4)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + 12d0*cima*coupl(nGC_1466)*&
                      coupl(nGC_376) - 30d0*cima*coupl(nGC_1466)*coupl(nGC_478 &
                      )*coupl(nGC_836)**2d0*sq2**2d0 - 3d0*cima*coupl(nGC_1468 &
                      )*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 3d0*cima*&
                      coupl(nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2** &
                      2d0 - 3d0*cima*coupl(nGC_1476)*coupl(nGC_478)*coupl(     &
                      nGC_836)**2d0*sq2**2d0 - 3d0*cima*coupl(nGC_368)*coupl(  &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 + 12d0*cima*coupl( &
                      nGC_376)*coupl(nGC_4) - 30d0*cima*coupl(nGC_4)*coupl(    &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*coupl(  &
                      nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 - 6d0*coupl(nGC_13 &
                      )*coupl(nGC_1466)*coupl(nGC_4) + coupl(nGC_13)*coupl(    &
                      nGC_836)**4d0*sq2**4d0 - 6d0*coupl(nGC_1466)*coupl(      &
                      nGC_1474)*coupl(nGC_478) - 6d0*coupl(nGC_1466)*coupl(    &
                      nGC_1476)*coupl(nGC_478) - 48d0*coupl(nGC_1466)*coupl(   &
                      nGC_4)*coupl(nGC_478) - 6d0*coupl(nGC_1466)*coupl(nGC_830&
                      )*coupl(nGC_836)*sq2**2d0 - 6d0*coupl(nGC_1468)*coupl(   &
                      nGC_1474)*coupl(nGC_478) - 6d0*coupl(nGC_1468)*coupl(    &
                      nGC_4)*coupl(nGC_478) - 6d0*coupl(nGC_1476)*coupl(nGC_368&
                      )*coupl(nGC_478) - 6d0*coupl(nGC_368)*coupl(nGC_4)*coupl(&
                      nGC_478) - 12d0*coupl(nGC_376)*coupl(nGC_836)**2d0*sq2** &
                      2d0 - 18d0*coupl(nGC_4)*coupl(nGC_830)*coupl(nGC_836)*sq2&
                      **2d0 + 12d0*coupl(nGC_478)*coupl(nGC_836)**4d0*sq2**4d0 &
                      )/(384d0*pi**2d0)
    coupl(nGC_2531) = Nc*coupl(nGC_836)*sq2*(-2d0*cima*coupl(nGC_10)*coupl(    &
                      nGC_1466) + 2d0*cima*coupl(nGC_10)*coupl(nGC_4) - 14d0*  &
                      cima*coupl(nGC_1466)*coupl(nGC_52) + 4d0*cima*coupl(     &
                      nGC_1468)*coupl(nGC_52) + 8d0*cima*coupl(nGC_1474)*coupl(&
                      nGC_52) - 4d0*cima*coupl(nGC_1476)*coupl(nGC_52) - 8d0*  &
                      cima*coupl(nGC_368)*coupl(nGC_52) + 14d0*cima*coupl(nGC_4&
                      )*coupl(nGC_52) + 6d0*cima*coupl(nGC_46)*coupl(nGC_836)* &
                      sq2**2d0 - coupl(nGC_10)*coupl(nGC_836)**2d0*sq2**2d0 -  &
                      10d0*coupl(nGC_52)*coupl(nGC_836)**2d0*sq2**2d0)/(384d0* &
                      pi**2d0)
    coupl(nGC_2532) = Nc*coupl(nGC_836)*sq2*(2d0*cima*coupl(nGC_10)*coupl(     &
                      nGC_1466) - 2d0*cima*coupl(nGC_10)*coupl(nGC_4) + 14d0*  &
                      cima*coupl(nGC_1466)*coupl(nGC_52) + 8d0*cima*coupl(     &
                      nGC_1468)*coupl(nGC_52) + 4d0*cima*coupl(nGC_1474)*coupl(&
                      nGC_52) - 8d0*cima*coupl(nGC_1476)*coupl(nGC_52) - 4d0*  &
                      cima*coupl(nGC_368)*coupl(nGC_52) - 14d0*cima*coupl(nGC_4&
                      )*coupl(nGC_52) + 6d0*cima*coupl(nGC_46)*coupl(nGC_836)* &
                      sq2**2d0 - coupl(nGC_10)*coupl(nGC_836)**2d0*sq2**2d0 -  &
                      10d0*coupl(nGC_52)*coupl(nGC_836)**2d0*sq2**2d0)/(384d0* &
                      pi**2d0)
    coupl(nGC_4333) = -coupl(nGC_4332)
    coupl(nGC_2552) = Nc*(-3d0*cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836&
                      )**2d0*sq2**2d0 - 3d0*cima*coupl(nGC_13)*coupl(nGC_4)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + 12d0*cima*coupl(nGC_1466)*&
                      coupl(nGC_376) - 30d0*cima*coupl(nGC_1466)*coupl(nGC_478 &
                      )*coupl(nGC_836)**2d0*sq2**2d0 - 3d0*cima*coupl(nGC_1468 &
                      )*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 3d0*cima*&
                      coupl(nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2** &
                      2d0 - 3d0*cima*coupl(nGC_1476)*coupl(nGC_478)*coupl(     &
                      nGC_836)**2d0*sq2**2d0 - 3d0*cima*coupl(nGC_368)*coupl(  &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 + 12d0*cima*coupl( &
                      nGC_376)*coupl(nGC_4) - 30d0*cima*coupl(nGC_4)*coupl(    &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*coupl(  &
                      nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 - 3d0*coupl(nGC_13 &
                      )*coupl(nGC_1466)**2d0 - 3d0*coupl(nGC_13)*coupl(nGC_4)**&
                      2d0 + coupl(nGC_13)*coupl(nGC_836)**4d0*sq2**4d0 - 24d0* &
                      coupl(nGC_1466)**2d0*coupl(nGC_478) - 6d0*coupl(nGC_1466 &
                      )*coupl(nGC_1468)*coupl(nGC_478) - 6d0*coupl(nGC_1466)*  &
                      coupl(nGC_368)*coupl(nGC_478) - 18d0*coupl(nGC_1466)*    &
                      coupl(nGC_830)*coupl(nGC_836)*sq2**2d0 - 3d0*coupl(      &
                      nGC_1468)**2d0*coupl(nGC_478) - 3d0*coupl(nGC_1474)**2d0*&
                      coupl(nGC_478) - 6d0*coupl(nGC_1474)*coupl(nGC_4)*coupl( &
                      nGC_478) - 3d0*coupl(nGC_1476)**2d0*coupl(nGC_478) - 6d0*&
                      coupl(nGC_1476)*coupl(nGC_4)*coupl(nGC_478) - 3d0*coupl( &
                      nGC_368)**2d0*coupl(nGC_478) - 12d0*coupl(nGC_376)*coupl(&
                      nGC_836)**2d0*sq2**2d0 - 24d0*coupl(nGC_4)**2d0*coupl(   &
                      nGC_478) - 6d0*coupl(nGC_4)*coupl(nGC_830)*coupl(nGC_836 &
                      )*sq2**2d0 + 12d0*coupl(nGC_478)*coupl(nGC_836)**4d0*sq2 &
                      **4d0)/(384d0*pi**2d0)
    coupl(nGC_2535) = Nc*(-4d0*cima*coupl(nGC_13)*coupl(nGC_1466)*coupl(nGC_836&
                      )**2d0*sq2**2d0 - 2d0*cima*coupl(nGC_13)*coupl(nGC_4)*   &
                      coupl(nGC_836)**2d0*sq2**2d0 + 12d0*cima*coupl(nGC_1466)*&
                      coupl(nGC_376) - 40d0*cima*coupl(nGC_1466)*coupl(nGC_478 &
                      )*coupl(nGC_836)**2d0*sq2**2d0 - 4d0*cima*coupl(nGC_1468 &
                      )*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 2d0*cima*&
                      coupl(nGC_1474)*coupl(nGC_478)*coupl(nGC_836)**2d0*sq2** &
                      2d0 - 2d0*cima*coupl(nGC_1476)*coupl(nGC_478)*coupl(     &
                      nGC_836)**2d0*sq2**2d0 - 4d0*cima*coupl(nGC_368)*coupl(  &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 + 12d0*cima*coupl( &
                      nGC_376)*coupl(nGC_4) - 20d0*cima*coupl(nGC_4)*coupl(    &
                      nGC_478)*coupl(nGC_836)**2d0*sq2**2d0 - 8d0*cima*coupl(  &
                      nGC_830)*coupl(nGC_836)**3d0*sq2**4d0 - 6d0*coupl(nGC_13 &
                      )*coupl(nGC_1466)*coupl(nGC_4) + coupl(nGC_13)*coupl(    &
                      nGC_836)**4d0*sq2**4d0 - 6d0*coupl(nGC_1466)*coupl(      &
                      nGC_1474)*coupl(nGC_478) - 6d0*coupl(nGC_1466)*coupl(    &
                      nGC_1476)*coupl(nGC_478) - 48d0*coupl(nGC_1466)*coupl(   &
                      nGC_4)*coupl(nGC_478) - 12d0*coupl(nGC_1466)*coupl(      &
                      nGC_830)*coupl(nGC_836)*sq2**2d0 - 6d0*coupl(nGC_1468)*  &
                      coupl(nGC_1474)*coupl(nGC_478) - 6d0*coupl(nGC_1468)*    &
                      coupl(nGC_4)*coupl(nGC_478) - 6d0*coupl(nGC_1476)*coupl( &
                      nGC_368)*coupl(nGC_478) - 6d0*coupl(nGC_368)*coupl(nGC_4 &
                      )*coupl(nGC_478) - 12d0*coupl(nGC_376)*coupl(nGC_836)**  &
                      2d0*sq2**2d0 - 12d0*coupl(nGC_4)*coupl(nGC_830)*coupl(   &
                      nGC_836)*sq2**2d0 + 12d0*coupl(nGC_478)*coupl(nGC_836)** &
                      4d0*sq2**4d0)/(384d0*pi**2d0)
  end subroutine fill_CTcouplings_mdl3
end module fill_ctcouplings3
