!******************************************************************************!
!                                                                              !
!    ctparameter4.f90                                                          !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   ctparameter4.f90                               |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module ctparameter4
  use input_mdl, only: DeltaUV,muUV,muMS
  use class_ctparameters
  use modelintegrals
  use class_couplings
contains
subroutine set_ctparameter4()
  if (dZgs_QCD2_scheme .eq. 1) then
    DeltaUV = DeltaUV + log(muUV**2/muMS**2)
    dZgs_QCD2 = (DeltaUV*coupl(nGC_3)*(cima*Nc*coupl(nGC_1)**2d0 + 40d0*cima*Nc&
                *coupl(nGC_2)**2d0 - 12d0*Nc*coupl(nGC_2)*coupl(nGC_3) + 12d0* &
                cima*Nc*coupl(nGC_3)**2d0 + 32d0*cima*coupl(nGC_3)**2d0)/(24d0*&
                gs) + cima*Ten64*coupl(nGC_3)**3d0/(3d0*gs))/(16d0*pi**2d0)
    dZgs_QCD2 = cone*real(dZgs_QCD2,kind=dp)
    DeltaUV = DeltaUV - log(muUV**2/muMS**2)
  end if 
end subroutine set_ctparameter4
end module ctparameter4
