!******************************************************************************!
!                                                                              !
!    lcVSVSVS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSVSVS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSVSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec
  contains
    subroutine loopVSVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSVSVS0)
!       c0*(Metric(1,3)*P(5,1) - Metric(1,3)*P(5,3) - Metric(1,5)*P(3,1) + Metric
!       (1,5)*P(3,5) + Metric(3,5)*P(1,3) - Metric(3,5)*P(1,5))
        x6 = -w3(0)*w5(0) + w3(1)*w5(1) + w3(2)*w5(2) + w3(3)*w5(3)
        x15 = cima*co(0)*w2(0)*w4(0)
        do j = riMaxIn, 0, -1
          x0 = -w3(0)*wl(0,j) + w3(1)*wl(1,j) + w3(2)*wl(2,j) + w3(3)*wl(3,j)
          x1 = w5(0)*x0
          x2 = -w5(0)*wl(0,j) + w5(1)*wl(1,j) + w5(2)*wl(2,j) + w5(3)*wl(3,j)
          x3 = w3(1)*x2
          x4 = w3(2)*x2
          x5 = w3(3)*x2
          x7 = wl(0,j)*x6
          x8 = w5(1)*x0
          x9 = w5(2)*x0
          x10 = w5(3)*x0
          x11 = w3(0)*x2
          x12 = wl(1,j)*x6
          x13 = wl(2,j)*x6
          x14 = wl(3,j)*x6
          wp(0,j) = x15*(P1(0)*x1 - P1(0)*x11 + P1(1)*x3 - P1(1)*x8 + P1(2)*x4 &
                     - P1(2)*x9 - P1(3)*x10 + P1(3)*x5 - P3(0)*x1 + P3(0)*x7 - &
                    P3(1)*x12 + P3(1)*x8 - P3(2)*x13 + P3(2)*x9 + P3(3)*x10 -  &
                    P3(3)*x14 + P5(0)*x11 - P5(0)*x7 + P5(1)*x12 - P5(1)*x3 +  &
                    P5(2)*x13 - P5(2)*x4 + P5(3)*x14 - P5(3)*x5)
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) + x15*(-w3(mu)*x2 + w5(mu)*x0)
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSVSVS
end module lcVSVSVS
