!******************************************************************************!
!                                                                              !
!    lcVVSV.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVSV.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec
  contains
    subroutine loopVVSV(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,  &
    riMaxIn, riMaxOut, rankInc)
      use class_vertices
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVSV0)
!       c0*(Metric(1,2)*P(4,1) - Metric(1,2)*P(4,2) - Metric(1,4)*P(2,1) + Metric
!       (1,4)*P(2,4) + Metric(2,4)*P(1,2) - Metric(2,4)*P(1,4))
        x1 = cima*co(0)*w3(0)
        do j = riMaxIn, 0, -1
          x0 = -w2(0)*wl(0,j) + w2(1)*wl(1,j) + w2(2)*wl(2,j) + w2(3)*wl(3,j)
          x0vec = w2(:)*wl(0,j)
          x1vec = w2(1)*wl(:,j)
          x2vec = w2(2)*wl(:,j)
          x3vec = w2(3)*wl(:,j)
          x4vec = w2(:)*wl(1,j)
          x5vec = w2(:)*wl(2,j)
          x6vec = w2(:)*wl(3,j)
          x7vec = w2(0)*wl(:,j)
          wp(:,j) = x1*(P1(0)*x0vec - 2*P1(0)*x7vec + 2*P1(1)*x1vec - P1(1)*   &
                    x4vec + 2*P1(2)*x2vec - P1(2)*x5vec + 2*P1(3)*x3vec - P1(3 &
                    )*x6vec - P1(:)*x0 + 2*P2(0)*x0vec - P2(0)*x7vec + P2(1)*  &
                    x1vec - 2*P2(1)*x4vec + P2(2)*x2vec - 2*P2(2)*x5vec + P2(3 &
                    )*x3vec - 2*P2(3)*x6vec + P2(:)*x0 + P3(0)*x0vec - P3(0)*  &
                    x7vec + P3(1)*x1vec - P3(1)*x4vec + P3(2)*x2vec - P3(2)*   &
                    x5vec + P3(3)*x3vec - P3(3)*x6vec)
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(:,riOut) = wp(:,riOut) + x1*(-gg(:,mu)*x0 + w2(:)*wl(mu,j) - 2* &
                          w2(mu)*wl(:,j))
          end do 
        end do 
      end select 
    end subroutine loopVVSV
end module lcVVSV
