!******************************************************************************!
!                                                                              !
!    tcFFa.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFFa.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeFFa(ty, co, w1, P1, PL1, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FFa0)
!       GammaP(-1,2,1)*P(-1,1)*c0
!       GammaM(-1,2,1)*P(-1,1)*c1
!       ProjP(2,1)*c2
!       ProjM(2,1)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:)
      x0 = pl(0)*w1(1)
      x1 = pl(3)*w1(0)
      x2 = P1(1)*co(0)
      x3 = pl(0)*w1(0)
      x4 = pl(3)*w1(1)
      x5 = P1(3)*co(0)
      x6 = co(2)*m
      x7 = P1(0)*co(0)
      x8 = pl(0)*w1(2)
      x9 = pl(3)*w1(3)
      x10 = P1(0)*co(1)
      x11 = m*w1(2)
      x12 = P1(1)*co(1)
      x13 = m*w1(3)
      x14 = P1(3)*co(1)
      x15 = P1(2)*cima*co(0)
      x16 = P1(2)*cima*co(1)
      x17 = pl(1)*w1(0)
      x18 = pl(2)*w1(1)
      x19 = pl(1)*w1(1)
      x20 = pl(2)*w1(0)
      x21 = pl(1)*w1(3)
      x22 = pl(2)*w1(2)
      x23 = co(3)*m
      x24 = pl(1)*w1(2)
      x25 = pl(3)*w1(2)
      x26 = m*w1(0)
      x27 = m*w1(1)
      x28 = pl(0)*w1(3)
      x29 = pl(2)*w1(3)
      wout(0) = -co(3)*x8 - co(3)*x9 + w1(0)*x6 + x10*x11 + x11*x14 + x12*x13  &
                 - x13*x16 - x15*(x0 - x1) + x2*(x0 + x1) + x5*(x3 - x4) - x7*(&
                x3 + x4)
      wout(1) = -co(3)*x21 - co(3)*x22 + w1(1)*x6 + x10*x13 + x11*x12 + x11*x16&
                 - x13*x14 + x15*(x17 - x18) + x2*(x17 + x18) - x5*(x19 - x20  &
                ) - x7*(x19 + x20)
      wout(2) = -co(2)*x17 + co(2)*x4 + w1(2)*x23 - x10*(x24 - x9) - x12*(x21  &
                 - x25) - x14*(x24 + x9) + x15*x27 + x16*(x21 + x25) - x2*x27  &
                 - x26*x5 + x26*x7
      wout(3) = -co(2)*x0 + co(2)*x20 + w1(3)*x23 - x10*(-x22 + x28) - x12*(-  &
                x29 + x8) + x14*(x22 + x28) - x15*x26 - x16*(x29 + x8) - x2*x26&
                 + x27*x5 + x27*x7
    else
      x0 = co(1)*w1(2)
      x1 = P1(1)*co(1)
      x2 = co(1)*w1(3)
      x3 = P1(2)*cima
      x4 = co(0)*w1(0)
      x5 = co(0)*w1(1)
      wout(0) = P1(0)*x0 + P1(3)*x0 + co(2)*w1(0) + w1(3)*x1 - x2*x3
      wout(1) = P1(0)*x2 - P1(3)*x2 + co(2)*w1(1) + w1(2)*x1 + x0*x3
      wout(2) = P1(0)*x4 - P1(1)*x5 - P1(3)*x4 + co(3)*w1(2) + x3*x5
      wout(3) = P1(0)*x5 - P1(1)*x4 + P1(3)*x5 + co(3)*w1(3) - x3*x4
    end if 
      end select 
    end subroutine treeFFa
end module tcFFa
