!******************************************************************************!
!                                                                              !
!    tcFSFa.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFSFa.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFSFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeFSFa(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FSFa0)
!       c0*(GammaP(-1,3,1)*P(-1,2) + 2*GammaP(-1,3,1)*P(-1,3))
!       c1*(GammaM(-1,3,1)*P(-1,2) + 2*GammaM(-1,3,1)*P(-1,3))
!       ProjP(3,1)*c2
!       ProjM(3,1)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = pl(0)*w1(0)
      x1 = pl(3)*w1(1)
      x2 = x0 + x1
      x3 = P2(0)*co(0)
      x4 = co(2)*m
      x5 = pl(0)*w1(1)
      x6 = pl(3)*w1(0)
      x7 = x5 + x6
      x8 = P2(1)*co(0)
      x9 = x0 - x1
      x10 = P2(3)*co(0)
      x11 = pl(0)*w1(2)
      x12 = pl(3)*w1(3)
      x13 = 2*P1(1)*co(0)
      x14 = 2*P1(3)*co(0)
      x15 = 2*P1(0)*co(0)
      x16 = x5 - x6
      x17 = P2(2)*cima*co(0)
      x18 = P2(0)*co(1)*m
      x19 = P2(1)*co(1)*m
      x20 = P2(3)*co(1)*m
      x21 = 2*P1(0)*co(1)
      x22 = m*w1(2)
      x23 = 2*P1(1)*co(1)
      x24 = m*w1(3)
      x25 = 2*P1(3)*co(1)
      x26 = 2*P1(2)*cima*co(0)
      x27 = P2(2)*cima*co(1)
      x28 = 2*P1(2)*cima*co(1)
      x29 = pl(1)*w1(1)
      x30 = pl(2)*w1(0)
      x31 = x29 + x30
      x32 = x29 - x30
      x33 = pl(1)*w1(0)
      x34 = pl(2)*w1(1)
      x35 = x33 + x34
      x36 = pl(1)*w1(3)
      x37 = pl(2)*w1(2)
      x38 = x33 - x34
      x39 = pl(1)*w1(2)
      x40 = -x12 + x39
      x41 = P2(0)*co(1)
      x42 = pl(3)*w1(2)
      x43 = x36 - x42
      x44 = P2(1)*co(1)
      x45 = x12 + x39
      x46 = P2(3)*co(1)
      x47 = co(3)*m
      x48 = P2(1)*co(0)*m
      x49 = P2(3)*co(0)*m
      x50 = P2(0)*co(0)*m
      x51 = x36 + x42
      x52 = m*w1(0)
      x53 = m*w1(1)
      x54 = pl(0)*w1(3)
      x55 = -x37 + x54
      x56 = pl(2)*w1(3)
      x57 = x11 - x56
      x58 = x37 + x54
      x59 = x11 + x56
      wout(0) = w2(0)*(-co(3)*x11 - co(3)*x12 + w1(0)*x4 - w1(2)*x18 - w1(2)*  &
                x20 - w1(3)*x19 - x10*x9 - x13*x7 - x14*x9 + x15*x2 + x16*x17  &
                 + x16*x26 + x2*x3 - x21*x22 - x22*x25 - x23*x24 + x24*x27 +   &
                x24*x28 - x7*x8)
      wout(1) = w2(0)*(-co(3)*x36 - co(3)*x37 + w1(1)*x4 - w1(2)*x19 - w1(3)*  &
                x18 + w1(3)*x20 + x10*x32 - x13*x35 + x14*x32 + x15*x31 - x17* &
                x38 - x21*x24 - x22*x23 - x22*x27 - x22*x28 + x24*x25 - x26*x38&
                 + x3*x31 - x35*x8)
      wout(2) = w2(0)*(co(2)*x1 - co(2)*x33 + w1(0)*x49 - w1(0)*x50 + w1(1)*x48&
                 + w1(2)*x47 + x13*x53 + x14*x52 - x15*x52 - x17*x53 + x21*x40 &
                 + x23*x43 + x25*x45 - x26*x53 - x27*x51 - x28*x51 + x40*x41 + &
                x43*x44 + x45*x46)
      wout(3) = w2(0)*(co(2)*x30 - co(2)*x5 + w1(0)*x48 - w1(1)*x49 - w1(1)*x50&
                 + w1(3)*x47 + x13*x52 - x14*x53 - x15*x53 + x17*x52 + x21*x55 &
                 + x23*x57 - x25*x58 + x26*x52 + x27*x59 + x28*x59 + x41*x55 + &
                x44*x57 - x46*x58)
    else
      x0 = co(1)*w1(2)
      x1 = co(1)*w1(3)
      x2 = 2*P1(0)
      x3 = 2*P1(1)
      x4 = 2*P1(3)
      x5 = P2(2)*cima
      x6 = 2*P1(2)*cima
      x7 = co(0)*w1(1)
      x8 = co(0)*w1(0)
      wout(0) = w2(0)*(-P2(0)*x0 - P2(1)*x1 - P2(3)*x0 + co(2)*w1(0) - x0*x2 - &
                x0*x4 - x1*x3 + x1*x5 + x1*x6)
      wout(1) = w2(0)*(-P2(0)*x1 - P2(1)*x0 + P2(3)*x1 + co(2)*w1(1) - x0*x3 - &
                x0*x5 - x0*x6 - x1*x2 + x1*x4)
      wout(2) = w2(0)*(-P2(0)*x8 + P2(1)*x7 + P2(3)*x8 + co(3)*w1(2) - x2*x8 + &
                x3*x7 + x4*x8 - x5*x7 - x6*x7)
      wout(3) = w2(0)*(-P2(0)*x7 + P2(1)*x8 - P2(3)*x7 + co(3)*w1(3) - x2*x7 + &
                x3*x8 - x4*x7 + x5*x8 + x6*x8)
    end if 
      end select 
    end subroutine treeFSFa
end module tcFSFa
