!******************************************************************************!
!                                                                              !
!    tcFSSFa.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFSSFa.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFSSFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeFSSFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FSSFa0)
!       c0*(GammaP(-1,4,1)*P(-1,1)/2 + GammaP(-1,4,1)*P(-1,2) + GammaP(-1,4,1)*P 
!       (-1,3))
!       c1*(GammaM(-1,4,1)*P(-1,1)/2 + GammaM(-1,4,1)*P(-1,2) + GammaM(-1,4,1)*P 
!       (-1,3))
!       ProjP(4,1)*c2
!       ProjM(4,1)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(0)*w1(1)
      x1 = pl(3)*w1(0)
      x2 = x0 + x1
      x3 = P1(1)*co(0)
      x4 = pl(0)*w1(0)
      x5 = pl(3)*w1(1)
      x6 = x4 - x5
      x7 = P1(3)*co(0)
      x8 = x4 + x5
      x9 = P1(0)*co(0)
      x10 = 2*P2(0)*co(0)
      x11 = 2*P3(0)*co(0)
      x12 = pl(0)*w1(2)
      x13 = 2*co(3)
      x14 = pl(3)*w1(3)
      x15 = 2*co(0)*x2
      x16 = 2*P2(3)*co(0)
      x17 = 2*P3(3)*co(0)
      x18 = m*w1(0)
      x19 = 2*co(2)
      x20 = P1(0)*co(1)
      x21 = m*w1(2)
      x22 = P1(1)*co(1)
      x23 = m*w1(3)
      x24 = P1(3)*co(1)
      x25 = x0 - x1
      x26 = P1(2)*cima*co(0)
      x27 = 2*cima*co(0)*x25
      x28 = 2*co(1)*m*w1(2)
      x29 = 2*co(1)*m*w1(3)
      x30 = 2*P2(3)*co(1)
      x31 = 2*P3(3)*co(1)
      x32 = P1(2)*cima*co(1)
      x33 = P2(2)*cima
      x34 = P3(2)*cima
      x35 = w2(0)*w3(0)/2
      x36 = pl(1)*w1(0)
      x37 = pl(2)*w1(1)
      x38 = x36 + x37
      x39 = pl(1)*w1(1)
      x40 = pl(2)*w1(0)
      x41 = x39 + x40
      x42 = x39 - x40
      x43 = pl(1)*w1(3)
      x44 = pl(2)*w1(2)
      x45 = 2*co(0)*x38
      x46 = m*w1(1)
      x47 = x36 - x37
      x48 = 2*co(0)*x47
      x49 = pl(1)*w1(2)
      x50 = -x14 + x49
      x51 = pl(3)*w1(2)
      x52 = x43 - x51
      x53 = x14 + x49
      x54 = 2*co(1)*x50
      x55 = 2*co(1)*x52
      x56 = x43 + x51
      x57 = 2*P2(1)*co(0)
      x58 = 2*P3(1)*co(0)
      x59 = 2*cima*co(1)*x56
      x60 = 2*P2(2)*cima*co(0)
      x61 = 2*P3(2)*cima*co(0)
      x62 = pl(0)*w1(3)
      x63 = x44 + x62
      x64 = -x44 + x62
      x65 = pl(2)*w1(3)
      x66 = x12 - x65
      x67 = 2*co(1)*x64
      x68 = 2*co(1)*x66
      x69 = x12 + x65
      x70 = 2*co(1)*x69
      wout(0) = x35*(P2(0)*x28 + P2(1)*x15 + P2(1)*x29 - P2(2)*x27 + P3(0)*x28 &
                 + P3(1)*x15 + P3(1)*x29 - P3(2)*x27 - x10*x8 - x11*x8 - x12*  &
                x13 - x13*x14 + x16*x6 + x17*x6 + x18*x19 + x2*x3 + x20*x21 +  &
                x21*x24 + x21*x30 + x21*x31 + x22*x23 - x23*x32 - x25*x26 - x29&
                *x33 - x29*x34 + x6*x7 - x8*x9)
      wout(1) = x35*(P2(0)*x29 + P2(1)*x28 + P2(1)*x45 + P3(0)*x29 + P3(1)*x28 &
                 + P3(1)*x45 - x10*x41 - x11*x41 - x13*x43 - x13*x44 - x16*x42 &
                 - x17*x42 + x19*x46 + x20*x23 + x21*x22 + x21*x32 - x23*x24 - &
                x23*x30 - x23*x31 + x26*x47 + x28*x33 + x28*x34 + x3*x38 + x33*&
                x48 + x34*x48 - x41*x9 - x42*x7)
      wout(2) = x35*(-P2(0)*x54 - P2(1)*x55 + P2(2)*x59 - P3(0)*x54 - P3(1)*x55&
                 + P3(2)*x59 + x10*x18 + x11*x18 + x13*x21 - x16*x18 - x17*x18 &
                 - x18*x7 + x18*x9 - x19*x36 + x19*x5 - x20*x50 - x22*x52 - x24&
                *x53 + x26*x46 - x3*x46 - x30*x53 - x31*x53 + x32*x56 - x46*x57&
                 - x46*x58 + x46*x60 + x46*x61)
      wout(3) = x35*(-P2(0)*x67 - P2(1)*x68 - P3(0)*x67 - P3(1)*x68 - x0*x19 + &
                x10*x46 + x11*x46 + x13*x23 + x16*x46 + x17*x46 - x18*x26 - x18&
                *x3 - x18*x57 - x18*x58 - x18*x60 - x18*x61 + x19*x40 - x20*x64&
                 - x22*x66 + x24*x63 + x30*x63 + x31*x63 - x32*x69 - x33*x70 - &
                x34*x70 + x46*x7 + x46*x9)
    else
      x0 = 2*co(2)
      x1 = co(1)*w1(2)
      x2 = co(1)*w1(3)
      x3 = 2*co(1)*w1(2)
      x4 = 2*co(1)*w1(3)
      x5 = P1(2)*cima
      x6 = P2(2)*cima
      x7 = P3(2)*cima
      x8 = w2(0)*w3(0)/2
      x9 = 2*P2(0)
      x10 = 2*co(3)
      x11 = co(0)*w1(0)
      x12 = co(0)*w1(1)
      x13 = P1(3)*co(0)
      x14 = 2*co(0)*w1(1)
      x15 = 2*co(0)*w1(0)
      x16 = 2*cima*co(0)*w1(1)
      wout(0) = x8*(P1(0)*x1 + P1(1)*x2 + P1(3)*x1 + P2(0)*x3 + P2(1)*x4 + P2(3&
                )*x3 + P3(0)*x3 + P3(1)*x4 + P3(3)*x3 + w1(0)*x0 - x2*x5 - x4* &
                x6 - x4*x7)
      wout(1) = x8*(P1(0)*x2 + P1(1)*x1 - P1(3)*x2 + P2(1)*x3 - P2(3)*x4 + P3(0&
                )*x4 + P3(1)*x3 - P3(3)*x4 + w1(1)*x0 + x1*x5 + x2*x9 + x3*x6  &
                 + x3*x7)
      wout(2) = x8*(P1(0)*x11 - P1(1)*x12 - P2(1)*x14 + P2(2)*x16 - P2(3)*x15  &
                 + P3(0)*x15 - P3(1)*x14 + P3(2)*x16 - P3(3)*x15 - w1(0)*x13 + &
                w1(2)*x10 + x11*x9 + x12*x5)
      wout(3) = x8*(P1(0)*x12 - P1(1)*x11 - P2(1)*x15 + P2(3)*x14 + P3(0)*x14  &
                 - P3(1)*x15 + P3(3)*x14 + w1(1)*x13 + w1(3)*x10 - x11*x5 + x12&
                *x9 - x15*x6 - x15*x7)
    end if 
      end select 
    end subroutine treeFSSFa
end module tcFSSFa
