!******************************************************************************!
!                                                                              !
!    tcFaSF.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFaSF.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFaSF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeFaSF(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FaSF0)
!       c0*(2*GammaP(-1,1,3)*P(-1,1) + GammaP(-1,1,3)*P(-1,2))
!       c1*(2*GammaM(-1,1,3)*P(-1,1) + GammaM(-1,1,3)*P(-1,2))
!       ProjP(1,3)*c2
!       ProjM(1,3)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = pl(1)*w1(0)
      x1 = pl(2)*w1(1)
      x2 = x0 - x1
      x3 = P2(0)*co(1)
      x4 = pl(1)*w1(1)
      x5 = pl(2)*w1(0)
      x6 = x4 - x5
      x7 = P2(1)*co(1)
      x8 = x0 + x1
      x9 = P2(3)*co(1)
      x10 = co(2)*m
      x11 = pl(1)*w1(2)
      x12 = pl(2)*w1(3)
      x13 = 2*P1(0)*co(1)
      x14 = 2*P1(1)*co(1)
      x15 = 2*P1(3)*co(1)
      x16 = P2(0)*co(0)
      x17 = m*w1(2)
      x18 = x4 + x5
      x19 = P2(2)*cima*co(1)
      x20 = P2(1)*co(0)
      x21 = m*w1(3)
      x22 = P2(3)*co(0)*m
      x23 = 2*P1(1)*co(0)
      x24 = 2*P1(3)*co(0)
      x25 = 2*P1(0)*co(0)
      x26 = 2*P1(2)*cima*co(1)
      x27 = P2(2)*cima*co(0)
      x28 = 2*P1(2)*cima*co(0)
      x29 = pl(0)*w1(1)
      x30 = pl(3)*w1(0)
      x31 = x29 - x30
      x32 = pl(0)*w1(0)
      x33 = pl(3)*w1(1)
      x34 = x32 - x33
      x35 = pl(0)*w1(3)
      x36 = x29 + x30
      x37 = pl(3)*w1(2)
      x38 = x32 + x33
      x39 = pl(0)*w1(2)
      x40 = x12 + x39
      x41 = co(3)*m
      x42 = pl(2)*w1(2)
      x43 = x35 + x42
      x44 = -x12 + x39
      x45 = P2(3)*co(0)
      x46 = P2(0)*co(1)*m
      x47 = P2(1)*co(1)*m
      x48 = P2(3)*co(1)*m
      x49 = x35 - x42
      x50 = 2*P1(0)*co(1)*m
      x51 = 2*P1(1)*co(1)*m
      x52 = 2*P1(3)*co(1)*m
      x53 = P2(2)*cima*co(1)*m
      x54 = 2*P1(2)*cima*co(1)*m
      x55 = pl(1)*w1(3)
      x56 = x37 + x55
      x57 = -x37 + x55
      x58 = pl(3)*w1(3)
      x59 = x11 + x58
      x60 = x11 - x58
      wout(0) = w2(0)*(co(3)*x11 - co(3)*x12 + w1(0)*x10 - w1(2)*x22 + x13*x2  &
                 + x14*x6 + x15*x8 + x16*x17 - x17*x24 + x17*x25 + x18*x19 +   &
                x18*x26 + x2*x3 - x20*x21 - x21*x23 - x21*x27 - x21*x28 + x6*x7&
                 + x8*x9)
      wout(1) = w2(0)*(co(3)*x35 - co(3)*x37 + w1(1)*x10 + w1(3)*x22 + x13*x31 &
                 + x14*x34 - x15*x36 + x16*x21 - x17*x20 - x17*x23 + x17*x27 + &
                x17*x28 - x19*x38 + x21*x24 + x21*x25 - x26*x38 + x3*x31 + x34*&
                x7 - x36*x9)
      wout(2) = w2(0)*(co(2)*x1 + co(2)*x32 + w1(0)*x46 + w1(0)*x48 + w1(0)*x50&
                 + w1(0)*x52 + w1(1)*x47 + w1(1)*x51 + w1(1)*x53 + w1(1)*x54 + &
                w1(2)*x41 + x16*x40 - x20*x43 - x23*x43 - x24*x44 + x25*x40 -  &
                x27*x49 - x28*x49 - x44*x45)
      wout(3) = w2(0)*(co(2)*x30 + co(2)*x4 + w1(0)*x47 + w1(0)*x51 - w1(0)*x53&
                 - w1(0)*x54 + w1(1)*x46 - w1(1)*x48 + w1(1)*x50 - w1(1)*x52 + &
                w1(3)*x41 + x16*x56 - x20*x59 - x23*x59 + x24*x57 + x25*x56 +  &
                x27*x60 + x28*x60 + x45*x57)
    else
      x0 = co(0)*w1(2)
      x1 = co(0)*w1(3)
      x2 = 2*P1(1)
      x3 = 2*P1(3)
      x4 = 2*P1(0)
      x5 = P2(2)*cima
      x6 = 2*P1(2)*cima
      x7 = P2(0)*co(1)
      x8 = P2(1)*co(1)
      x9 = P2(3)*co(1)
      x10 = co(1)*w1(0)
      x11 = co(1)*w1(1)
      wout(0) = w2(0)*(P2(0)*x0 - P2(1)*x1 - P2(3)*x0 + co(2)*w1(0) - x0*x3 +  &
                x0*x4 - x1*x2 - x1*x5 - x1*x6)
      wout(1) = w2(0)*(P2(0)*x1 - P2(1)*x0 + P2(3)*x1 + co(2)*w1(1) - x0*x2 +  &
                x0*x5 + x0*x6 + x1*x3 + x1*x4)
      wout(2) = w2(0)*(co(3)*w1(2) + w1(0)*x7 + w1(0)*x9 + w1(1)*x8 + x10*x3 + &
                x10*x4 + x11*x2 + x11*x5 + x11*x6)
      wout(3) = w2(0)*(co(3)*w1(3) + w1(0)*x8 + w1(1)*x7 - w1(1)*x9 + x10*x2 - &
                x10*x5 - x10*x6 - x11*x3 + x11*x4)
    end if 
      end select 
    end subroutine treeFaSF
end module tcFaSF
