!******************************************************************************!
!                                                                              !
!    tcSFFa.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFFa.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeSFFa(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFFa0)
!       c0*(GammaP(-1,3,2)*P(-1,1) + 2*GammaP(-1,3,2)*P(-1,3))
!       c1*(GammaM(-1,3,2)*P(-1,1) + 2*GammaM(-1,3,2)*P(-1,3))
!       ProjP(3,2)*c2
!       ProjM(3,2)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = pl(0)*w2(0)
      x1 = pl(3)*w2(1)
      x2 = x0 + x1
      x3 = P1(0)*co(0)
      x4 = co(2)*m
      x5 = pl(0)*w2(1)
      x6 = pl(3)*w2(0)
      x7 = x5 + x6
      x8 = P1(1)*co(0)
      x9 = x0 - x1
      x10 = P1(3)*co(0)
      x11 = pl(0)*w2(2)
      x12 = pl(3)*w2(3)
      x13 = 2*P2(1)*co(0)
      x14 = 2*P2(3)*co(0)
      x15 = 2*P2(0)*co(0)
      x16 = x5 - x6
      x17 = P1(2)*cima*co(0)
      x18 = P1(0)*co(1)*m
      x19 = P1(1)*co(1)*m
      x20 = P1(3)*co(1)*m
      x21 = 2*P2(0)*co(1)
      x22 = m*w2(2)
      x23 = 2*P2(1)*co(1)
      x24 = m*w2(3)
      x25 = 2*P2(3)*co(1)
      x26 = 2*P2(2)*cima*co(0)
      x27 = P1(2)*cima*co(1)
      x28 = 2*P2(2)*cima*co(1)
      x29 = pl(1)*w2(1)
      x30 = pl(2)*w2(0)
      x31 = x29 + x30
      x32 = x29 - x30
      x33 = pl(1)*w2(0)
      x34 = pl(2)*w2(1)
      x35 = x33 + x34
      x36 = pl(1)*w2(3)
      x37 = pl(2)*w2(2)
      x38 = x33 - x34
      x39 = pl(1)*w2(2)
      x40 = -x12 + x39
      x41 = P1(0)*co(1)
      x42 = pl(3)*w2(2)
      x43 = x36 - x42
      x44 = P1(1)*co(1)
      x45 = x12 + x39
      x46 = P1(3)*co(1)
      x47 = co(3)*m
      x48 = m*w2(1)
      x49 = m*w2(0)
      x50 = x36 + x42
      x51 = pl(0)*w2(3)
      x52 = -x37 + x51
      x53 = pl(2)*w2(3)
      x54 = x11 - x53
      x55 = x37 + x51
      x56 = x11 + x53
      wout(0) = w1(0)*(-co(3)*x11 - co(3)*x12 + w2(0)*x4 - w2(2)*x18 - w2(2)*  &
                x20 - w2(3)*x19 - x10*x9 - x13*x7 - x14*x9 + x15*x2 + x16*x17  &
                 + x16*x26 + x2*x3 - x21*x22 - x22*x25 - x23*x24 + x24*x27 +   &
                x24*x28 - x7*x8)
      wout(1) = w1(0)*(-co(3)*x36 - co(3)*x37 + w2(1)*x4 - w2(2)*x19 - w2(3)*  &
                x18 + w2(3)*x20 + x10*x32 - x13*x35 + x14*x32 + x15*x31 - x17* &
                x38 - x21*x24 - x22*x23 - x22*x27 - x22*x28 + x24*x25 - x26*x38&
                 + x3*x31 - x35*x8)
      wout(2) = w1(0)*(co(2)*x1 - co(2)*x33 + w2(2)*x47 + x10*x49 + x13*x48 +  &
                x14*x49 - x15*x49 - x17*x48 + x21*x40 + x23*x43 + x25*x45 - x26&
                *x48 - x27*x50 - x28*x50 - x3*x49 + x40*x41 + x43*x44 + x45*x46&
                 + x48*x8)
      wout(3) = w1(0)*(co(2)*x30 - co(2)*x5 + w2(3)*x47 - x10*x48 + x13*x49 -  &
                x14*x48 - x15*x48 + x17*x49 + x21*x52 + x23*x54 - x25*x55 + x26&
                *x49 + x27*x56 + x28*x56 - x3*x48 + x41*x52 + x44*x54 - x46*x55&
                 + x49*x8)
    else
      x0 = co(1)*w2(2)
      x1 = co(1)*w2(3)
      x2 = 2*co(1)*w2(2)
      x3 = 2*co(1)*w2(3)
      x4 = P1(2)*cima
      x5 = P2(2)*cima
      x6 = co(0)*w2(1)
      x7 = co(0)*w2(0)
      x8 = 2*co(0)*w2(0)
      x9 = 2*co(0)*w2(1)
      wout(0) = w1(0)*(-P1(0)*x0 - P1(1)*x1 - P1(3)*x0 - P2(0)*x2 - P2(1)*x3 - &
                P2(3)*x2 + co(2)*w2(0) + x1*x4 + x3*x5)
      wout(1) = w1(0)*(-P1(0)*x1 - P1(1)*x0 + P1(3)*x1 - P2(0)*x3 - P2(1)*x2 + &
                P2(3)*x3 + co(2)*w2(1) - x0*x4 - x2*x5)
      wout(2) = w1(0)*(-P1(0)*x7 + P1(1)*x6 + P1(3)*x7 - P2(0)*x8 + P2(1)*x9 + &
                P2(3)*x8 + co(3)*w2(2) - x4*x6 - x5*x9)
      wout(3) = w1(0)*(-P1(0)*x6 + P1(1)*x7 - P1(3)*x6 - P2(0)*x9 + P2(1)*x8 - &
                P2(3)*x9 + co(3)*w2(3) + x4*x7 + x5*x8)
    end if 
      end select 
    end subroutine treeSFFa
end module tcSFFa
