!******************************************************************************!
!                                                                              !
!    tcSFSFa.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFSFa.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFSFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeSFSFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFSFa0)
!       c0*(GammaP(-1,4,2)*P(-1,1) + GammaP(-1,4,2)*P(-1,2)/2 + GammaP(-1,4,2)*P 
!       (-1,3))
!       c1*(GammaM(-1,4,2)*P(-1,1) + GammaM(-1,4,2)*P(-1,2)/2 + GammaM(-1,4,2)*P 
!       (-1,3))
!       ProjP(4,2)*c2
!       ProjM(4,2)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(0)*w2(1)
      x1 = pl(3)*w2(0)
      x2 = x0 + x1
      x3 = P2(1)*co(0)
      x4 = pl(0)*w2(0)
      x5 = pl(3)*w2(1)
      x6 = x4 - x5
      x7 = P2(3)*co(0)
      x8 = x4 + x5
      x9 = P2(0)*co(0)
      x10 = 2*P1(0)*co(0)
      x11 = 2*P3(0)*co(0)
      x12 = pl(0)*w2(2)
      x13 = 2*co(3)
      x14 = pl(3)*w2(3)
      x15 = 2*co(0)*x2
      x16 = 2*P1(3)*co(0)
      x17 = 2*P3(3)*co(0)
      x18 = 2*co(2)
      x19 = m*w2(0)
      x20 = P2(0)*co(1)
      x21 = m*w2(2)
      x22 = P2(1)*co(1)*m
      x23 = P2(3)*co(1)
      x24 = x0 - x1
      x25 = P2(2)*cima*co(0)
      x26 = 2*cima*co(0)*x24
      x27 = 2*co(1)*m*w2(2)
      x28 = 2*P1(1)*co(1)
      x29 = m*w2(3)
      x30 = 2*P1(3)*co(1)
      x31 = 2*P3(1)*co(1)
      x32 = 2*P3(3)*co(1)
      x33 = P2(2)*cima*co(1)
      x34 = 2*co(1)*m*w2(3)
      x35 = P1(2)*cima
      x36 = P3(2)*cima
      x37 = w1(0)*w3(0)/2
      x38 = pl(1)*w2(0)
      x39 = pl(2)*w2(1)
      x40 = x38 + x39
      x41 = pl(1)*w2(1)
      x42 = pl(2)*w2(0)
      x43 = x41 + x42
      x44 = x41 - x42
      x45 = pl(1)*w2(3)
      x46 = pl(2)*w2(2)
      x47 = 2*co(0)*x40
      x48 = m*w2(1)
      x49 = x38 - x39
      x50 = 2*co(0)*x49
      x51 = pl(1)*w2(2)
      x52 = -x14 + x51
      x53 = pl(3)*w2(2)
      x54 = x45 - x53
      x55 = P2(1)*co(1)
      x56 = x14 + x51
      x57 = 2*co(1)*x52
      x58 = x45 + x53
      x59 = 2*co(0)*m*w2(1)
      x60 = 2*co(1)*x58
      x61 = pl(0)*w2(3)
      x62 = x46 + x61
      x63 = -x46 + x61
      x64 = pl(2)*w2(3)
      x65 = x12 - x64
      x66 = 2*co(1)*x63
      x67 = x12 + x64
      x68 = 2*co(0)*m*w2(0)
      x69 = 2*cima*co(1)*x67
      wout(0) = x37*(P1(0)*x27 + P1(1)*x15 - P1(2)*x26 + P3(0)*x27 + P3(1)*x15 &
                 - P3(2)*x26 + w2(3)*x22 - x10*x8 - x11*x8 - x12*x13 - x13*x14 &
                 + x16*x6 + x17*x6 + x18*x19 + x2*x3 + x20*x21 + x21*x23 + x21*&
                x30 + x21*x32 - x24*x25 + x28*x29 + x29*x31 - x29*x33 - x34*x35&
                 - x34*x36 + x6*x7 - x8*x9)
      wout(1) = x37*(P1(0)*x34 + P1(1)*x47 + P3(0)*x34 + P3(1)*x47 + w2(2)*x22 &
                 - x10*x43 - x11*x43 - x13*x45 - x13*x46 - x16*x44 - x17*x44 + &
                x18*x48 + x20*x29 + x21*x28 + x21*x31 + x21*x33 - x23*x29 + x25&
                *x49 + x27*x35 + x27*x36 - x29*x30 - x29*x32 + x3*x40 + x35*x50&
                 + x36*x50 - x43*x9 - x44*x7)
      wout(2) = x37*(-P1(0)*x57 - P1(1)*x59 - P3(0)*x57 - P3(1)*x59 + x10*x19  &
                 + x11*x19 + x13*x21 - x16*x19 - x17*x19 - x18*x38 + x18*x5 -  &
                x19*x7 + x19*x9 - x20*x52 - x23*x56 + x25*x48 - x28*x54 - x3*  &
                x48 - x30*x56 - x31*x54 - x32*x56 + x33*x58 + x35*x59 + x35*x60&
                 + x36*x59 + x36*x60 - x54*x55)
      wout(3) = x37*(-P1(0)*x66 - P1(1)*x68 - P1(2)*x69 - P3(0)*x66 - P3(1)*x68&
                 - P3(2)*x69 - x0*x18 + x10*x48 + x11*x48 + x13*x29 + x16*x48  &
                 + x17*x48 + x18*x42 - x19*x25 - x19*x3 - x20*x63 + x23*x62 -  &
                x28*x65 + x30*x62 - x31*x65 + x32*x62 - x33*x67 - x35*x68 - x36&
                *x68 + x48*x7 + x48*x9 - x55*x65)
    else
      x0 = 2*co(2)
      x1 = co(1)*w2(2)
      x2 = co(1)*w2(3)
      x3 = 2*P1(0)
      x4 = 2*P1(1)
      x5 = 2*P1(3)
      x6 = 2*P3(0)
      x7 = 2*P3(1)
      x8 = 2*P3(3)
      x9 = P2(2)*cima
      x10 = 2*P1(2)*cima
      x11 = 2*P3(2)*cima
      x12 = w1(0)*w3(0)/2
      x13 = 2*co(3)
      x14 = co(0)*w2(0)
      x15 = co(0)*w2(1)
      x16 = P2(3)*co(0)
      wout(0) = x12*(P2(0)*x1 + P2(1)*x2 + P2(3)*x1 + w2(0)*x0 + x1*x3 + x1*x5 &
                 + x1*x6 + x1*x8 - x10*x2 - x11*x2 + x2*x4 + x2*x7 - x2*x9)
      wout(1) = x12*(P2(0)*x2 + P2(1)*x1 - P2(3)*x2 + w2(1)*x0 + x1*x10 + x1*  &
                x11 + x1*x4 + x1*x7 + x1*x9 + x2*x3 - x2*x5 + x2*x6 - x2*x8)
      wout(2) = x12*(P2(0)*x14 - P2(1)*x15 - w2(0)*x16 + w2(2)*x13 + x10*x15 + &
                x11*x15 + x14*x3 - x14*x5 + x14*x6 - x14*x8 - x15*x4 - x15*x7  &
                 + x15*x9)
      wout(3) = x12*(P2(0)*x15 - P2(1)*x14 + w2(1)*x16 + w2(3)*x13 - x10*x14 - &
                x11*x14 - x14*x4 - x14*x7 - x14*x9 + x15*x3 + x15*x5 + x15*x6  &
                 + x15*x8)
    end if 
      end select 
    end subroutine treeSFSFa
end module tcSFSFa
