!******************************************************************************!
!                                                                              !
!    tcSFaF.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFaF.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFaF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeSFaF(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFaF0)
!       c0*(GammaP(-1,2,3)*P(-1,1) + 2*GammaP(-1,2,3)*P(-1,2))
!       c1*(GammaM(-1,2,3)*P(-1,1) + 2*GammaM(-1,2,3)*P(-1,2))
!       ProjP(2,3)*c2
!       ProjM(2,3)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = pl(1)*w2(0)
      x1 = pl(2)*w2(1)
      x2 = x0 - x1
      x3 = P1(0)*co(1)
      x4 = pl(1)*w2(1)
      x5 = pl(2)*w2(0)
      x6 = x4 - x5
      x7 = P1(1)*co(1)
      x8 = x0 + x1
      x9 = P1(3)*co(1)
      x10 = co(2)*m
      x11 = pl(1)*w2(2)
      x12 = pl(2)*w2(3)
      x13 = 2*P2(0)*co(1)
      x14 = 2*P2(1)*co(1)
      x15 = 2*P2(3)*co(1)
      x16 = P1(0)*co(0)
      x17 = m*w2(2)
      x18 = x4 + x5
      x19 = P1(2)*cima*co(1)
      x20 = P1(1)*co(0)
      x21 = m*w2(3)
      x22 = P1(3)*co(0)*m
      x23 = 2*P2(1)*co(0)
      x24 = 2*P2(3)*co(0)
      x25 = 2*P2(0)*co(0)
      x26 = 2*P2(2)*cima*co(1)
      x27 = P1(2)*cima*co(0)
      x28 = 2*P2(2)*cima*co(0)
      x29 = pl(0)*w2(1)
      x30 = pl(3)*w2(0)
      x31 = x29 - x30
      x32 = pl(0)*w2(0)
      x33 = pl(3)*w2(1)
      x34 = x32 - x33
      x35 = pl(0)*w2(3)
      x36 = x29 + x30
      x37 = pl(3)*w2(2)
      x38 = x32 + x33
      x39 = pl(0)*w2(2)
      x40 = x12 + x39
      x41 = co(3)*m
      x42 = pl(2)*w2(2)
      x43 = x35 + x42
      x44 = -x12 + x39
      x45 = P1(3)*co(0)
      x46 = m*w2(0)
      x47 = m*w2(1)
      x48 = x35 - x42
      x49 = pl(1)*w2(3)
      x50 = x37 + x49
      x51 = -x37 + x49
      x52 = pl(3)*w2(3)
      x53 = x11 + x52
      x54 = x11 - x52
      wout(0) = w1(0)*(co(3)*x11 - co(3)*x12 + w2(0)*x10 - w2(2)*x22 + x13*x2  &
                 + x14*x6 + x15*x8 + x16*x17 - x17*x24 + x17*x25 + x18*x19 +   &
                x18*x26 + x2*x3 - x20*x21 - x21*x23 - x21*x27 - x21*x28 + x6*x7&
                 + x8*x9)
      wout(1) = w1(0)*(co(3)*x35 - co(3)*x37 + w2(1)*x10 + w2(3)*x22 + x13*x31 &
                 + x14*x34 - x15*x36 + x16*x21 - x17*x20 - x17*x23 + x17*x27 + &
                x17*x28 - x19*x38 + x21*x24 + x21*x25 - x26*x38 + x3*x31 + x34*&
                x7 - x36*x9)
      wout(2) = w1(0)*(co(2)*x1 + co(2)*x32 + w2(2)*x41 + x13*x46 + x14*x47 +  &
                x15*x46 + x16*x40 + x19*x47 - x20*x43 - x23*x43 - x24*x44 + x25&
                *x40 + x26*x47 - x27*x48 - x28*x48 + x3*x46 - x44*x45 + x46*x9 &
                 + x47*x7)
      wout(3) = w1(0)*(co(2)*x30 + co(2)*x4 + w2(3)*x41 + x13*x47 + x14*x46 -  &
                x15*x47 + x16*x50 - x19*x46 - x20*x53 - x23*x53 + x24*x51 + x25&
                *x50 - x26*x46 + x27*x54 + x28*x54 + x3*x47 + x45*x51 + x46*x7 &
                 - x47*x9)
    else
      x0 = co(0)*w2(2)
      x1 = co(0)*w2(3)
      x2 = 2*P2(1)
      x3 = 2*P2(3)
      x4 = 2*P2(0)
      x5 = P1(2)*cima
      x6 = 2*P2(2)*cima
      x7 = co(1)*w2(0)
      x8 = co(1)*w2(1)
      wout(0) = w1(0)*(P1(0)*x0 - P1(1)*x1 - P1(3)*x0 + co(2)*w2(0) - x0*x3 +  &
                x0*x4 - x1*x2 - x1*x5 - x1*x6)
      wout(1) = w1(0)*(P1(0)*x1 - P1(1)*x0 + P1(3)*x1 + co(2)*w2(1) - x0*x2 +  &
                x0*x5 + x0*x6 + x1*x3 + x1*x4)
      wout(2) = w1(0)*(P1(0)*x7 + P1(1)*x8 + P1(3)*x7 + co(3)*w2(2) + x2*x8 +  &
                x3*x7 + x4*x7 + x5*x8 + x6*x8)
      wout(3) = w1(0)*(P1(0)*x8 + P1(1)*x7 - P1(3)*x8 + co(3)*w2(3) + x2*x7 -  &
                x3*x8 + x4*x8 - x5*x7 - x6*x7)
    end if 
      end select 
    end subroutine treeSFaF
end module tcSFaF
