!******************************************************************************!
!                                                                              !
!    tcSFaSF.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFaSF.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFaSF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeSFaSF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFaSF0)
!       c0*(GammaP(-1,2,4)*P(-1,1) + GammaP(-1,2,4)*P(-1,3) + GammaP(-1,2,4)*P(-1
!       ,4)/2)
!       c1*(GammaM(-1,2,4)*P(-1,1) + GammaM(-1,2,4)*P(-1,3) + GammaM(-1,2,4)*P(-1
!       ,4)/2)
!       ProjP(2,4)*c2
!       ProjM(2,4)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(1)*w2(0)
      x1 = pl(2)*w2(1)
      x2 = co(1)*(x0 - x1)
      x3 = pl(1)*w2(1)
      x4 = pl(2)*w2(0)
      x5 = co(1)*(x3 - x4)
      x6 = co(1)*(x0 + x1)
      x7 = pl(2)*w2(3)
      x8 = 2*co(3)
      x9 = 2*co(2)
      x10 = pl(1)*w2(2)
      x11 = co(0)*m*w2(2)
      x12 = cima*co(1)*(x3 + x4)
      x13 = P2(1)*co(0)
      x14 = m*w2(3)
      x15 = P1(1)*co(0)*m
      x16 = P3(1)*co(0)
      x17 = co(0)*m*w2(3)
      x18 = P2(2)*cima
      x19 = P1(2)*cima
      x20 = P3(2)*cima
      x21 = w1(0)*w3(0)/2
      x22 = pl(0)*w2(1)
      x23 = pl(3)*w2(0)
      x24 = co(1)*(x22 - x23)
      x25 = pl(0)*w2(0)
      x26 = pl(3)*w2(1)
      x27 = co(1)*(x25 - x26)
      x28 = co(1)*(x22 + x23)
      x29 = pl(3)*w2(2)
      x30 = pl(0)*w2(3)
      x31 = m*w2(2)
      x32 = cima*co(1)*(x25 + x26)
      x33 = pl(0)*w2(2)
      x34 = co(0)*(x33 + x7)
      x35 = pl(2)*w2(2)
      x36 = x30 + x35
      x37 = co(0)*(x33 - x7)
      x38 = P1(1)*co(0)
      x39 = co(1)*m*w2(0)
      x40 = co(1)*m*w2(1)
      x41 = cima*co(0)*(x30 - x35)
      x42 = pl(1)*w2(3)
      x43 = co(0)*(x29 + x42)
      x44 = co(0)*(-x29 + x42)
      x45 = pl(3)*w2(3)
      x46 = x10 + x45
      x47 = cima*co(0)*(x10 - x45)
      wout(0) = x21*(P1(0)*x11 + P1(0)*x2 + P1(1)*x5 + P1(2)*x12 - P1(3)*x11 + &
                P1(3)*x6 - P2(0)*x11 - P2(0)*x2 - P2(1)*x5 - P2(2)*x12 + P2(3)*&
                x11 - P2(3)*x6 + P3(0)*x11 + P3(0)*x2 + P3(1)*x5 + P3(2)*x12 - &
                P3(3)*x11 + P3(3)*x6 + m*w2(0)*x9 - w2(3)*x15 + x10*x8 + x13*  &
                x14 - x14*x16 + x17*x18 - x17*x19 - x17*x20 - x7*x8)
      wout(1) = x21*(P1(0)*x17 + P1(0)*x24 + P1(1)*x27 - P1(2)*x32 + P1(3)*x17 &
                 - P1(3)*x28 - P2(0)*x17 - P2(0)*x24 - P2(1)*x27 + P2(2)*x32 - &
                P2(3)*x17 + P2(3)*x28 + P3(0)*x17 + P3(0)*x24 + P3(1)*x27 - P3(&
                2)*x32 + P3(3)*x17 - P3(3)*x28 + m*w2(1)*x9 - w2(2)*x15 - x11* &
                x18 + x11*x19 + x11*x20 + x13*x31 - x16*x31 - x29*x8 + x30*x8)
      wout(2) = x21*(P1(0)*x34 + P1(0)*x39 + P1(1)*x40 - P1(2)*x41 - P1(3)*x37 &
                 + P1(3)*x39 - P2(0)*x34 - P2(0)*x39 - P2(1)*x40 + P2(2)*x41 + &
                P2(3)*x37 - P2(3)*x39 + P3(0)*x34 + P3(0)*x39 + P3(1)*x40 - P3(&
                2)*x41 - P3(3)*x37 + P3(3)*x39 + x1*x9 + x13*x36 - x16*x36 -   &
                x18*x40 + x19*x40 + x20*x40 + x25*x9 + x31*x8 - x36*x38)
      wout(3) = x21*(P1(0)*x40 + P1(0)*x43 + P1(1)*x39 + P1(2)*x47 - P1(3)*x40 &
                 + P1(3)*x44 - P2(0)*x40 - P2(0)*x43 - P2(1)*x39 - P2(2)*x47 + &
                P2(3)*x40 - P2(3)*x44 + P3(0)*x40 + P3(0)*x43 + P3(1)*x39 + P3(&
                2)*x47 - P3(3)*x40 + P3(3)*x44 + x13*x46 + x14*x8 - x16*x46 +  &
                x18*x39 - x19*x39 - x20*x39 + x23*x9 + x3*x9 - x38*x46)
    else
      x0 = 2*co(2)
      x1 = co(0)*w2(2)
      x2 = co(0)*w2(3)
      x3 = cima*co(0)*w2(3)
      x4 = P3(2)*cima
      x5 = w1(0)*w3(0)/2
      x6 = cima*co(0)*w2(2)
      x7 = 2*co(3)
      x8 = co(1)*w2(0)
      x9 = co(1)*w2(1)
      x10 = cima*co(1)*w2(1)
      x11 = cima*co(1)*w2(0)
      wout(0) = x5*(P1(0)*x1 - P1(1)*x2 - P1(2)*x3 - P1(3)*x1 - P2(0)*x1 + P2(1&
                )*x2 + P2(2)*x3 + P2(3)*x1 + P3(0)*x1 - P3(1)*x2 - P3(3)*x1 +  &
                w2(0)*x0 - x2*x4)
      wout(1) = x5*(P1(0)*x2 - P1(1)*x1 + P1(2)*x6 + P1(3)*x2 - P2(0)*x2 + P2(1&
                )*x1 - P2(2)*x6 - P2(3)*x2 + P3(0)*x2 - P3(1)*x1 + P3(3)*x2 +  &
                w2(1)*x0 + x1*x4)
      wout(2) = x5*(P1(0)*x8 + P1(1)*x9 + P1(2)*x10 + P1(3)*x8 - P2(0)*x8 - P2(&
                1)*x9 - P2(2)*x10 - P2(3)*x8 + P3(0)*x8 + P3(1)*x9 + P3(3)*x8  &
                 + w2(2)*x7 + x4*x9)
      wout(3) = x5*(P1(0)*x9 + P1(1)*x8 - P1(2)*x11 - P1(3)*x9 - P2(0)*x9 - P2(&
                1)*x8 + P2(2)*x11 + P2(3)*x9 + P3(0)*x9 + P3(1)*x8 - P3(3)*x9  &
                 + w2(3)*x7 - x4*x8)
    end if 
      end select 
    end subroutine treeSFaSF
end module tcSFaSF
