!******************************************************************************!
!                                                                              !
!    tcSSFFa.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSFFa.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSFFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeSSFFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSFFa0)
!       c0*(GammaP(-1,4,3)*P(-1,1) + GammaP(-1,4,3)*P(-1,2) + GammaP(-1,4,3)*P(-1
!       ,3)/2)
!       c1*(GammaM(-1,4,3)*P(-1,1) + GammaM(-1,4,3)*P(-1,2) + GammaM(-1,4,3)*P(-1
!       ,3)/2)
!       ProjP(4,3)*c2
!       ProjM(4,3)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(0)*w3(1)
      x1 = pl(3)*w3(0)
      x2 = x0 + x1
      x3 = P3(1)*co(0)
      x4 = pl(0)*w3(0)
      x5 = pl(3)*w3(1)
      x6 = x4 - x5
      x7 = P3(3)*co(0)
      x8 = x4 + x5
      x9 = P3(0)*co(0)
      x10 = 2*co(0)*x8
      x11 = pl(0)*w3(2)
      x12 = 2*co(3)
      x13 = pl(3)*w3(3)
      x14 = 2*co(0)*x2
      x15 = 2*P1(3)*co(0)
      x16 = 2*P2(3)*co(0)
      x17 = 2*co(2)
      x18 = m*w3(0)
      x19 = P3(0)*co(1)
      x20 = m*w3(2)
      x21 = P3(1)*co(1)
      x22 = m*w3(3)
      x23 = P3(3)*co(1)
      x24 = x0 - x1
      x25 = P3(2)*cima*co(0)
      x26 = 2*cima*co(0)*x24
      x27 = 2*co(1)*m*w3(2)
      x28 = 2*P1(1)*co(1)
      x29 = 2*P1(3)*co(1)
      x30 = 2*P2(1)*co(1)
      x31 = 2*P2(3)*co(1)
      x32 = P3(2)*cima*co(1)
      x33 = 2*co(1)*m*w3(3)
      x34 = P1(2)*cima
      x35 = P2(2)*cima
      x36 = w1(0)*w2(0)/2
      x37 = pl(1)*w3(0)
      x38 = pl(2)*w3(1)
      x39 = x37 + x38
      x40 = pl(1)*w3(1)
      x41 = pl(2)*w3(0)
      x42 = x40 + x41
      x43 = x40 - x41
      x44 = 2*co(0)*x42
      x45 = pl(1)*w3(3)
      x46 = pl(2)*w3(2)
      x47 = 2*co(0)*x39
      x48 = m*w3(1)
      x49 = x37 - x38
      x50 = 2*cima*co(0)*x49
      x51 = 2*cima*co(1)*m*w3(2)
      x52 = pl(1)*w3(2)
      x53 = -x13 + x52
      x54 = pl(3)*w3(2)
      x55 = x45 - x54
      x56 = x13 + x52
      x57 = 2*co(1)*x53
      x58 = x45 + x54
      x59 = P3(1)*co(0)*m
      x60 = 2*co(0)*m*w3(1)
      x61 = 2*co(0)*m*w3(0)
      x62 = 2*cima*co(1)*x58
      x63 = pl(0)*w3(3)
      x64 = x46 + x63
      x65 = -x46 + x63
      x66 = pl(2)*w3(3)
      x67 = x11 - x66
      x68 = 2*co(1)*x65
      x69 = x11 + x66
      x70 = 2*cima*co(1)*x69
      wout(0) = x36*(-P1(0)*x10 + P1(0)*x27 + P1(1)*x14 - P1(2)*x26 - P2(0)*x10&
                 + P2(0)*x27 + P2(1)*x14 - P2(2)*x26 - x11*x12 - x12*x13 + x15*&
                x6 + x16*x6 + x17*x18 + x19*x20 + x2*x3 + x20*x23 + x20*x29 +  &
                x20*x31 + x21*x22 + x22*x28 + x22*x30 - x22*x32 - x24*x25 - x33&
                *x34 - x33*x35 + x6*x7 - x8*x9)
      wout(1) = x36*(P1(0)*x33 - P1(0)*x44 + P1(1)*x47 + P1(2)*x50 + P1(2)*x51 &
                 + P2(0)*x33 - P2(0)*x44 + P2(1)*x47 + P2(2)*x50 + P2(2)*x51 - &
                x12*x45 - x12*x46 - x15*x43 - x16*x43 + x17*x48 + x19*x22 + x20&
                *x21 + x20*x28 + x20*x30 + x20*x32 - x22*x23 - x22*x29 - x22*  &
                x31 + x25*x49 + x3*x39 - x42*x9 - x43*x7)
      wout(2) = x36*(-P1(0)*x57 + P1(0)*x61 - P1(1)*x60 + P1(2)*x62 - P2(0)*x57&
                 + P2(0)*x61 - P2(1)*x60 + P2(2)*x62 - w3(1)*x59 + x12*x20 -   &
                x15*x18 - x16*x18 - x17*x37 + x17*x5 - x18*x7 + x18*x9 - x19*  &
                x53 - x21*x55 - x23*x56 + x25*x48 - x28*x55 - x29*x56 - x30*x55&
                 - x31*x56 + x32*x58 + x34*x60 + x35*x60)
      wout(3) = x36*(P1(0)*x60 - P1(0)*x68 - P1(1)*x61 - P1(2)*x70 + P2(0)*x60 &
                 - P2(0)*x68 - P2(1)*x61 - P2(2)*x70 - w3(0)*x59 - x0*x17 + x12&
                *x22 + x15*x48 + x16*x48 + x17*x41 - x18*x25 - x19*x65 - x21*  &
                x67 + x23*x64 - x28*x67 + x29*x64 - x30*x67 + x31*x64 - x32*x69&
                 - x34*x61 - x35*x61 + x48*x7 + x48*x9)
    else
      x0 = 2*co(2)
      x1 = P3(0)*co(1)
      x2 = co(1)*w3(3)
      x3 = co(1)*w3(2)
      x4 = 2*co(1)*w3(2)
      x5 = 2*P1(1)
      x6 = 2*co(1)*w3(3)
      x7 = P3(2)*cima
      x8 = P1(2)*cima
      x9 = P2(2)*cima
      x10 = w1(0)*w2(0)/2
      x11 = 2*co(3)
      x12 = co(0)*w3(0)
      x13 = co(0)*w3(1)
      x14 = 2*co(0)*w3(1)
      x15 = 2*co(0)*w3(0)
      wout(0) = x10*(P1(0)*x4 + P1(3)*x4 + P2(0)*x4 + P2(1)*x6 + P2(3)*x4 + P3(&
                1)*x2 + P3(3)*x3 + w3(0)*x0 + w3(2)*x1 + x2*x5 - x2*x7 - x6*x8 &
                 - x6*x9)
      wout(1) = x10*(P1(0)*x6 + P1(1)*x4 - P1(3)*x6 + P2(0)*x6 + P2(1)*x4 - P2(&
                3)*x6 + P3(1)*x3 - P3(3)*x2 + w3(1)*x0 + w3(3)*x1 + x3*x7 + x4*&
                x8 + x4*x9)
      wout(2) = x10*(P1(0)*x15 - P1(1)*x14 - P1(3)*x15 + P2(0)*x15 - P2(1)*x14 &
                 - P2(3)*x15 + P3(0)*x12 - P3(1)*x13 - P3(3)*x12 + w3(2)*x11 + &
                x13*x7 + x14*x8 + x14*x9)
      wout(3) = x10*(P1(0)*x14 + P1(3)*x14 + P2(0)*x14 - P2(1)*x15 + P2(3)*x14 &
                 + P3(0)*x13 - P3(1)*x12 + P3(3)*x13 + w3(3)*x11 - x12*x5 - x12&
                *x7 - x15*x8 - x15*x9)
    end if 
      end select 
    end subroutine treeSSFFa
end module tcSSFFa
