!******************************************************************************!
!                                                                              !
!    tcSSFaF.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSFaF.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSFaF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeSSFaF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSFaF0)
!       c0*(GammaP(-1,3,4)*P(-1,1) + GammaP(-1,3,4)*P(-1,2) + GammaP(-1,3,4)*P(-1
!       ,4)/2)
!       c1*(GammaM(-1,3,4)*P(-1,1) + GammaM(-1,3,4)*P(-1,2) + GammaM(-1,3,4)*P(-1
!       ,4)/2)
!       ProjP(3,4)*c2
!       ProjM(3,4)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(1)*w3(0)
      x1 = pl(2)*w3(1)
      x2 = co(1)*(x0 - x1)
      x3 = pl(1)*w3(1)
      x4 = pl(2)*w3(0)
      x5 = co(1)*(x3 - x4)
      x6 = co(1)*(x0 + x1)
      x7 = pl(2)*w3(3)
      x8 = 2*co(3)
      x9 = 2*co(2)*m
      x10 = pl(1)*w3(2)
      x11 = co(0)*m*w3(2)
      x12 = cima*co(1)*(x3 + x4)
      x13 = P2(0)*co(0)
      x14 = m*w3(2)
      x15 = co(0)*m*w3(3)
      x16 = P3(2)*cima
      x17 = m*w3(3)
      x18 = P1(2)*cima*co(0)
      x19 = P2(2)*cima
      x20 = w1(0)*w2(0)/2
      x21 = pl(0)*w3(1)
      x22 = pl(3)*w3(0)
      x23 = co(1)*(x21 - x22)
      x24 = pl(0)*w3(0)
      x25 = pl(3)*w3(1)
      x26 = co(1)*(x24 - x25)
      x27 = co(1)*(x21 + x22)
      x28 = pl(3)*w3(2)
      x29 = pl(0)*w3(3)
      x30 = cima*co(1)*(x24 + x25)
      x31 = pl(0)*w3(2)
      x32 = x31 + x7
      x33 = co(0)*x32
      x34 = pl(2)*w3(2)
      x35 = co(0)*(x29 + x34)
      x36 = co(0)*(x31 - x7)
      x37 = 2*co(2)
      x38 = co(1)*m*w3(0)
      x39 = co(1)*m*w3(1)
      x40 = x29 - x34
      x41 = cima*co(0)*x40
      x42 = cima*co(1)*m*w3(1)
      x43 = pl(1)*w3(3)
      x44 = x28 + x43
      x45 = co(0)*x44
      x46 = co(0)*(-x28 + x43)
      x47 = pl(3)*w3(3)
      x48 = co(0)*(x10 + x47)
      x49 = x10 - x47
      x50 = cima*co(0)*x49
      x51 = cima*co(1)*m*w3(0)
      wout(0) = x20*(P1(0)*x11 + P1(0)*x2 - P1(1)*x15 + P1(1)*x5 + P1(2)*x12 - &
                P1(3)*x11 + P1(3)*x6 + P2(0)*x2 - P2(1)*x15 + P2(1)*x5 + P2(2)*&
                x12 - P2(3)*x11 + P2(3)*x6 - P3(0)*x11 - P3(0)*x2 + P3(1)*x15  &
                 - P3(1)*x5 - P3(2)*x12 + P3(3)*x11 - P3(3)*x6 + w3(0)*x9 + x10&
                *x8 + x13*x14 + x15*x16 - x15*x19 - x17*x18 - x7*x8)
      wout(1) = x20*(P1(0)*x15 + P1(0)*x23 - P1(1)*x11 + P1(1)*x26 + P1(2)*cima&
                *x11 - P1(2)*x30 + P1(3)*x15 - P1(3)*x27 + P2(0)*x23 - P2(1)*  &
                x11 + P2(1)*x26 - P2(2)*x30 + P2(3)*x15 - P2(3)*x27 - P3(0)*x15&
                 - P3(0)*x23 + P3(1)*x11 - P3(1)*x26 + P3(2)*x30 - P3(3)*x15 + &
                P3(3)*x27 + w3(1)*x9 - x11*x16 + x11*x19 + x13*x17 - x28*x8 +  &
                x29*x8)
      wout(2) = x20*(P1(0)*x33 + P1(0)*x38 - P1(1)*x35 + P1(1)*x39 + P1(2)*x42 &
                 - P1(3)*x36 + P1(3)*x38 + P2(0)*x38 - P2(1)*x35 + P2(1)*x39 - &
                P2(2)*x41 + P2(2)*x42 - P2(3)*x36 + P2(3)*x38 - P3(0)*x33 - P3(&
                0)*x38 + P3(1)*x35 - P3(1)*x39 + P3(2)*x41 - P3(2)*x42 + P3(3)*&
                x36 - P3(3)*x38 + x1*x37 + x13*x32 + x14*x8 - x18*x40 + x24*x37&
                )
      wout(3) = x20*(P1(0)*x39 + P1(0)*x45 + P1(1)*x38 - P1(1)*x48 - P1(2)*x51 &
                 - P1(3)*x39 + P1(3)*x46 + P2(0)*x39 + P2(1)*x38 - P2(1)*x48 + &
                P2(2)*x50 - P2(2)*x51 - P2(3)*x39 + P2(3)*x46 - P3(0)*x39 - P3(&
                0)*x45 - P3(1)*x38 + P3(1)*x48 - P3(2)*x50 + P3(2)*x51 + P3(3)*&
                x39 - P3(3)*x46 + x13*x44 + x17*x8 + x18*x49 + x22*x37 + x3*x37&
                )
    else
      x0 = 2*co(2)
      x1 = co(0)*w3(2)
      x2 = co(0)*w3(3)
      x3 = P3(2)*cima
      x4 = P1(2)*cima
      x5 = P2(2)*cima
      x6 = w1(0)*w2(0)/2
      x7 = 2*co(3)
      x8 = co(1)*w3(0)
      x9 = co(1)*w3(1)
      wout(0) = x6*(P1(0)*x1 - P1(1)*x2 - P1(3)*x1 + P2(0)*x1 - P2(1)*x2 - P2(3&
                )*x1 - P3(0)*x1 + P3(1)*x2 + P3(3)*x1 + w3(0)*x0 + x2*x3 - x2* &
                x4 - x2*x5)
      wout(1) = x6*(P1(0)*x2 - P1(1)*x1 + P1(3)*x2 + P2(0)*x2 - P2(1)*x1 + P2(3&
                )*x2 - P3(0)*x2 + P3(1)*x1 - P3(3)*x2 + w3(1)*x0 - x1*x3 + x1* &
                x4 + x1*x5)
      wout(2) = x6*(P1(0)*x8 + P1(1)*x9 + P1(3)*x8 + P2(0)*x8 + P2(1)*x9 + P2(3&
                )*x8 - P3(0)*x8 - P3(1)*x9 - P3(3)*x8 + w3(2)*x7 - x3*x9 + x4* &
                x9 + x5*x9)
      wout(3) = x6*(P1(0)*x9 + P1(1)*x8 - P1(3)*x9 + P2(0)*x9 + P2(1)*x8 - P2(3&
                )*x9 - P3(0)*x9 - P3(1)*x8 + P3(3)*x9 + w3(3)*x7 + x3*x8 - x4* &
                x8 - x5*x8)
    end if 
      end select 
    end subroutine treeSSFaF
end module tcSSFaF
