!******************************************************************************!
!                                                                              !
!    tcSSVSVV.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSVSVV.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSVSVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeSSVSVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in), dimension(0:3) :: P5, PL5
      complex(kind=dp), intent(in), dimension(0:3) :: w5
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSVSVV0)
!       c0*(Metric(3,5)*P(6,3) - Metric(3,5)*P(6,5) - Metric(3,6)*P(5,3) + Metric
!       (3,6)*P(5,6) + Metric(5,6)*P(3,5) - Metric(5,6)*P(3,6))
        if (last) VB_last = .true.
        x0 = -w3(0)*w5(0) + w3(1)*w5(1) + w3(2)*w5(2) + w3(3)*w5(3)
        x0vec = w3(0)*w5(:)
        x1vec = w3(:)*w5(1)
        x2vec = w3(:)*w5(2)
        x3vec = w3(:)*w5(3)
        x4vec = w3(:)*w5(0)
        x5vec = w3(1)*w5(:)
        x6vec = w3(2)*w5(:)
        x7vec = w3(3)*w5(:)
        wout = co(0)*w1(0)*w2(0)*w4(0)*(P1(0)*x0vec - P1(0)*x4vec + P1(1)*x1vec&
                - P1(1)*x5vec + P1(2)*x2vec - P1(2)*x6vec + P1(3)*x3vec - P1(3 &
               )*x7vec + P2(0)*x0vec - P2(0)*x4vec + P2(1)*x1vec - P2(1)*x5vec &
                + P2(2)*x2vec - P2(2)*x6vec + P2(3)*x3vec - P2(3)*x7vec + P3(0 &
               )*x0vec - 2*P3(0)*x4vec + 2*P3(1)*x1vec - P3(1)*x5vec + 2*P3(2)*&
               x2vec - P3(2)*x6vec + 2*P3(3)*x3vec - P3(3)*x7vec - P3(:)*x0 +  &
               P4(0)*x0vec - P4(0)*x4vec + P4(1)*x1vec - P4(1)*x5vec + P4(2)*  &
               x2vec - P4(2)*x6vec + P4(3)*x3vec - P4(3)*x7vec + 2*P5(0)*x0vec &
                - P5(0)*x4vec + P5(1)*x1vec - 2*P5(1)*x5vec + P5(2)*x2vec - 2* &
               P5(2)*x6vec + P5(3)*x3vec - 2*P5(3)*x7vec + P5(:)*x0)
      end select 
    end subroutine treeSSVSVV
end module tcSSVSVV
