!******************************************************************************!
!                                                                              !
!    tcSVVV.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVVV.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeSVVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m, &
    wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVVV0)
!       c0*(Metric(2,3)*P(4,2) - Metric(2,3)*P(4,3) - Metric(2,4)*P(3,2) + Metric
!       (2,4)*P(3,4) + Metric(3,4)*P(2,3) - Metric(3,4)*P(2,4))
        if (last) VB_last = .true.
        x0 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x0vec = w2(0)*w3(:)
        x1vec = w2(:)*w3(1)
        x2vec = w2(:)*w3(2)
        x3vec = w2(:)*w3(3)
        x4vec = w2(:)*w3(0)
        x5vec = w2(1)*w3(:)
        x6vec = w2(2)*w3(:)
        x7vec = w2(3)*w3(:)
        wout = co(0)*w1(0)*(P1(0)*x0vec - P1(0)*x4vec + P1(1)*x1vec - P1(1)*   &
               x5vec + P1(2)*x2vec - P1(2)*x6vec + P1(3)*x3vec - P1(3)*x7vec + &
               P2(0)*x0vec - 2*P2(0)*x4vec + 2*P2(1)*x1vec - P2(1)*x5vec + 2*P2&
               (2)*x2vec - P2(2)*x6vec + 2*P2(3)*x3vec - P2(3)*x7vec - P2(:)*x0&
                + 2*P3(0)*x0vec - P3(0)*x4vec + P3(1)*x1vec - 2*P3(1)*x5vec +  &
               P3(2)*x2vec - 2*P3(2)*x6vec + P3(3)*x3vec - 2*P3(3)*x7vec + P3  &
               (:)*x0)
      case(SVVV1)
!       c0*(Metric(2,3)*P(4,3) - Metric(2,4)*P(3,4) - Metric(3,4)*P(2,3))
!       c1*(-Metric(2,3)*P(4,2) + Metric(2,4)*P(3,2) + Metric(3,4)*P(2,4))
        if (last) VB_last = .true.
        x0 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x0vec = co(0)*w2(:)*w3(0)
        x1vec = co(1)*w2(1)*w3(:)
        x2vec = co(1)*w2(2)*w3(:)
        x3vec = co(1)*w2(3)*w3(:)
        x4vec = co(1)*w2(:)
        x5vec = co(0)*w3(:)
        x1 = P3(1)*w2(1)
        x6vec = co(1)*w3(:)
        x7vec = co(1)*w2(0)*w3(:)
        x8vec = co(0)*w2(:)*w3(1)
        x9vec = co(0)*w2(:)*w3(2)
        x10vec = co(0)*w2(:)*w3(3)
        x11vec = co(0)*w2(:)
        x2 = P2(1)*w3(1)
        x3 = P2(3)*w3(3)
        x4 = P3(0)*w2(0)
        wout = w1(0)*(P1(0)*x0vec - P1(0)*x7vec + P1(1)*x1vec - P1(1)*x8vec +  &
               P1(2)*x2vec - P1(2)*x9vec - P1(3)*x10vec + P1(3)*x3vec + P2(0)* &
               w3(0)*x4vec + P2(0)*x0vec - P2(0)*x7vec + P2(1)*x1vec - P2(2)*w3&
               (2)*x4vec + P2(2)*x2vec - P2(2)*x9vec + P2(3)*x3vec + P2(:)*co(1&
               )*x0 + P3(0)*x0vec - P3(1)*x8vec + P3(2)*w2(2)*x5vec + P3(2)*   &
               x2vec - P3(2)*x9vec + P3(3)*w2(3)*x5vec - P3(3)*x10vec + P3(3)* &
               x3vec - P3(:)*co(0)*x0 + x1*x5vec + x1*x6vec - x11vec*x2 -      &
               x11vec*x3 - x2*x4vec - x3*x4vec - x4*x5vec - x4*x6vec)
      end select 
    end subroutine treeSVVV
end module tcSVVV
