!******************************************************************************!
!                                                                              !
!    tcVFSFa.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVFSFa.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVFSFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeVFSFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VFSFa0)
!       GammaP(1,4,2)*c0
!       GammaM(1,4,2)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(3)*w1(0)
      x1 = pl(3)*w1(3)
      x2 = pl(0)*w1(1)
      x3 = cima*w1(2)
      x4 = pl(0)*x3
      x5 = co(0)*w2(1)
      x6 = pl(0)*w1(3)
      x7 = pl(0)*w1(0)
      x8 = pl(3)*w1(1) + pl(3)*x3
      x9 = co(0)*w2(0)
      x10 = -w1(1) + x3
      x11 = co(1)*m*w2(3)
      x12 = w1(0) + w1(3)
      x13 = co(1)*m*w2(2)
      x14 = pl(1)*w1(0)
      x15 = pl(1)*w1(3)
      x16 = -pl(2)*w1(1) + pl(2)*x3
      x17 = pl(1)*w1(1)
      x18 = pl(2)*w1(3)
      x19 = -pl(2)*w1(0)
      x20 = pl(1)*x3
      x21 = w1(1) + x3
      x22 = w1(0) - w1(3)
      x23 = co(1)*w2(2)
      x24 = co(1)*w2(3)
      x25 = co(0)*m*w2(0)
      x26 = co(0)*m*w2(1)
      wout(0) = w3(0)*(x10*x11 - x12*x13 + x5*(x0 + x1 - x2 + x4) - x9*(x6 - x7&
                 + x8))
      wout(1) = w3(0)*(-x11*x22 - x13*x21 + x5*(x14 + x15 + x16) - x9*(x17 +   &
                x18 + x19 + x20))
      wout(2) = -w3(0)*(x10*x26 + x22*x25 + x23*(-x14 - x15 + x8) + x24*(x0 -  &
                x1 - x17 + x20))
      wout(3) = w3(0)*(-x12*x26 + x21*x25 + x23*(-x18 + x19 + x2 + x4) + x24*( &
                x16 - x6 + x7))
    else
      x0 = cima*w1(2)
      x1 = -w1(1) + x0
      x2 = w1(0) + w1(3)
      x3 = co(1)*w3(0)
      x4 = w1(1) + x0
      x5 = w1(0) - w1(3)
      x6 = co(0)*w3(0)
      wout(0) = x3*(-w2(2)*x2 + w2(3)*x1)
      wout(1) = -x3*(w2(2)*x4 + w2(3)*x5)
      wout(2) = -x6*(w2(0)*x5 + w2(1)*x1)
      wout(3) = x6*(w2(0)*x4 - w2(1)*x2)
    end if 
      end select 
    end subroutine treeVFSFa
end module tcVFSFa
