!******************************************************************************!
!                                                                              !
!    tcVSSFaF.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2020 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSSFaF.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 07/2020                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2020-08-04 12:55             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSSFaF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec
  contains
    subroutine treeVSSFaF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, den, m, wout, last, VB_last)
      use class_vertices
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSSFaF0)
!       GammaP(1,4,5)*c0
!       GammaM(1,4,5)*c1
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:) + PL4(:)
      x0 = pl(1)*w1(0)
      x1 = pl(1)*w1(3)
      x2 = cima*w1(2)
      x3 = -pl(2)*w1(1) + pl(2)*x2
      x4 = co(1)*w4(0)
      x5 = pl(1)*w1(1)
      x6 = pl(2)*w1(3)
      x7 = -pl(2)*w1(0)
      x8 = pl(1)*x2
      x9 = co(1)*w4(1)
      x10 = w1(1) + x2
      x11 = co(0)*m*w4(3)
      x12 = w1(0) - w1(3)
      x13 = co(0)*m*w4(2)
      x14 = w2(0)*w3(0)
      x15 = pl(3)*w1(0)
      x16 = pl(3)*w1(3)
      x17 = pl(0)*w1(1)
      x18 = pl(0)*x2
      x19 = pl(0)*w1(3)
      x20 = pl(0)*w1(0)
      x21 = pl(3)*w1(1) + pl(3)*x2
      x22 = -w1(1) + x2
      x23 = w1(0) + w1(3)
      x24 = co(0)*w4(3)
      x25 = co(0)*w4(2)
      x26 = co(1)*m*w4(0)
      x27 = co(1)*m*w4(1)
      wout(0) = x14*(x10*x11 - x12*x13 - x4*(x0 + x1 + x3) - x9*(x5 + x6 + x7  &
                 + x8))
      wout(1) = x14*(-x11*x23 - x13*x22 + x4*(x15 + x16 - x17 + x18) + x9*(x19 &
                 - x20 + x21))
      wout(2) = x14*(-x10*x27 - x23*x26 + x24*(x17 + x18 - x6 + x7) - x25*(-x19&
                 + x20 + x3))
      wout(3) = x14*(-x12*x27 + x22*x26 + x24*(-x0 - x1 + x21) - x25*(x15 - x16&
                 - x5 + x8))
    else
      x0 = cima*w1(2)
      x1 = w1(1) + x0
      x2 = w1(0) - w1(3)
      x3 = co(0)*w2(0)*w3(0)
      x4 = -w1(1) + x0
      x5 = w1(0) + w1(3)
      x6 = co(1)*w2(0)*w3(0)
      wout(0) = x3*(-w4(2)*x2 + w4(3)*x1)
      wout(1) = -x3*(w4(2)*x4 + w4(3)*x5)
      wout(2) = -x6*(w4(0)*x5 + w4(1)*x1)
      wout(3) = x6*(w4(0)*x4 - w4(1)*x2)
    end if 
      end select 
    end subroutine treeVSSFaF
end module tcVSSFaF
